var plugins_bb40132b_638b_4a9f_b028_d3fe47acc8d1 = 
{
    "init": function () {

	console.log("插件编写测试");

	this._afterLoadResources = function () {
		// 本函数将在所有资源加载完毕后，游戏开启前被执行
		// 可以在这个函数里面对资源进行一些操作。
		// 若需要进行切分图片，可以使用 core.splitImage() 函数，或直接在全塔属性-图片切分中操作
		// 
		core.ui.statusBar.init();
	}

	// 可以在任何地方（如afterXXX或自定义脚本事件）调用函数，方法为 core.plugin.xxx();
	// 从V2.6开始，插件中用this.XXX方式定义的函数也会被转发到core中，详见文档-脚本-函数的转发。
},
    "resizeTo11": function () {
	if (main.mode == 'editor') {
		return;
	}

	// 在不修改libs的情况下将页面适配为11x11
	core.__SIZE__ = 11;
	core.__PIXELS__ = core.__SIZE__ * 32;
	core.__HALF_SIZE__ = 5;
	// core.bigmap.width = core.__SIZE__;
	// core.bigmap.height = core.__SIZE__;
	core.actions.SIZE = core.__SIZE__;
	core.actions.HSIZE = core.__HALF_SIZE__;
	core.actions.LAST = core.__SIZE__ - 1;
	core.actions.CHOICES_LEFT = 3;
	core.actions.CHOICES_RIGHT = core.actions.LAST - core.actions.CHOICES_LEFT;
	core.ui.SIZE = core.__SIZE__;
	core.ui.HSIZE = core.__HALF_SIZE__;
	core.ui.LAST = core.__SIZE__ - 1;
	core.ui.PIXEL = core.__PIXELS__;
	core.ui.HPIXEL = core.__PIXELS__ / 2;
},
    "statusBar": function () {
	main.dom.floorMsgGroup.style.display = 'none';
	main.dom.statusBar.style.display = 'none';
	main.dom.toolBar.style.display = 'none';

	const GAMEVIEW_WIDTH = 640;
	const GAMEVIEW_HEIGHT = 422;

	const GAMEVIEW_WIDTH_VERTICAL = 388;
	const GAMEVIEW_HEIGHT_VERTICAL = 630;

	const BAR_WIDTH = 125;
	const BAR_HEIGHT_VERTICAL = 130;
	const BORDER_WIDTH = 18;
	const BORDER_HEIGHT = 24;
	
	const ITEM_BOX_LEFT = 13;
	const ITEM_BOX_TOP = 190;
	const ITEM_BOX_LEFT_VERTICAL = 219;
	const ITEM_BOX_TOP_VERTICAL = 10;

	const ITEM_ICON_OUTER_SIZE = 33;

	const EQUIP_BLOCK_LEFT = 525;
	const EQUIP_BLOCK_TOP = 40;
	const EQUIP_BLOCK_LEFT_VERTICAL = 108;
	const EQUIP_BLOCK_TOP_VERTICAL = 0;

	const KEY_BLOCK_LEFT = EQUIP_BLOCK_LEFT;
	const KEY_BLOCK_LEFT_VERTICAL = EQUIP_BLOCK_LEFT_VERTICAL;
	const KEY_BLOCK_TOP_VERTICAL = 86;

	const INFO_BLOCK_LEFT = EQUIP_BLOCK_LEFT;
	const INFO_BLOCK_TOP = 220;
	const INFO_BLOCK_LEFT_VERTICAL = 8;
	const INFO_BLOCK_TOP_VERTICAL = 538;

	const TOOL_BOX_LEFT = EQUIP_BLOCK_LEFT;
	const TOOL_BOX_TOP = 318;
	const TOOL_BOX_LEFT_VERTICAL = 278;
	const TOOL_BOX_TOP_VERTICAL = INFO_BLOCK_TOP_VERTICAL;

	const TOOL_ICON_OUTER_SIZE = 34;

	const INFO_BAR_HEIGHT = 22;
	const INFO_BAR_HEIGHT_VERTICAL = 18;
	const INFO_BAR_TOP = GAMEVIEW_HEIGHT - INFO_BAR_HEIGHT;
	const INFO_BAR_TOP_VERTICAL = GAMEVIEW_HEIGHT_VERTICAL - INFO_BAR_HEIGHT_VERTICAL;

	const TEXT_COLOR = "#E1E1E1";

	const FORCE_COUNTABLE_ITEMS = ["centerFly"];

	const outerBackground = document.createElement('canvas');
	outerBackground.style.position = 'absolute';
	outerBackground.style.zIndex = 5;
	outerBackground.id = 'outerBackground';
	main.dom.outerBackground = outerBackground;
	main.dom.startPanel.insertAdjacentElement('afterend', outerBackground);

	const outerUI = document.createElement('canvas');
	outerUI.style.position = 'absolute';
	outerUI.style.zIndex = 165;
	outerUI.id = 'outerUI';
	main.dom.outerUI = outerUI;
	outerBackground.insertAdjacentElement('afterend', outerUI);
	setTimeout(function () {
		// Should be executed immediately after init()
		main.canvas.outerUI = outerUI.getContext('2d');
	});
	outerUI.onclick = function (e) {
		try {
			e.preventDefault();
			if (!core.isPlaying()) return false;
			const left = core.dom.gameGroup.offsetLeft;
			const top = core.dom.gameGroup.offsetTop;
			const px = parseInt((e.clientX - left) / core.domStyle.scale),
				py = parseInt((e.clientY - top) / core.domStyle.scale);
			core.ui.statusBar.onclick(px, py);
		} catch (ee) {
			main.log(ee);
		}
	}

	const _resize_gameGroup = function (obj) {
		const gameGroup = core.dom.gameGroup;
		gameGroup.style.width = obj.totalWidth + "px";
		gameGroup.style.height = obj.totalHeight + "px";
		gameGroup.style.left = (obj.clientWidth - obj.totalWidth) / 2 + "px";
		gameGroup.style.top = (obj.clientHeight - obj.totalHeight) / 2 + "px";

		core.dom.musicBtn.style.right = (obj.clientWidth - obj.totalWidth) / 2 + "px";
		core.dom.musicBtn.style.bottom = (obj.clientHeight - obj.totalHeight) / 2 - 27 + "px";
		core.dom.enlargeBtn.style.right = (obj.clientWidth - obj.totalWidth) / 2 + 31 + "px";
		core.dom.enlargeBtn.style.bottom = (obj.clientHeight - obj.totalHeight) / 2 - 27 + "px";

		main.dom.startBackground.src = main.styles.startBackground;
	}

	const _resize_canvas = function (obj) {
		main.dom.outerBackground.style.width = obj.totalWidth + 'px';
		main.dom.outerBackground.style.height = obj.totalHeight + 'px';
		main.dom.outerUI.style.width = obj.totalWidth + 'px';
		main.dom.outerUI.style.height = obj.totalHeight + 'px';

		const innerSize = (obj.canvasWidth * core.domStyle.scale) + "px";
		for (let i = 0; i < core.dom.gameCanvas.length; ++i)
			core.dom.gameCanvas[i].style.width = core.dom.gameCanvas[i].style.height = innerSize;
		core.dom.gif.style.width = core.dom.gif.style.height = innerSize;
		core.dom.gif2.style.width = core.dom.gif2.style.height = innerSize;
		core.dom.gameDraw.style.width = core.dom.gameDraw.style.height = innerSize;
		core.dom.gameDraw.style.top = obj.gameDrawBox.top * core.domStyle.scale + "px";
		core.dom.gameDraw.style.left = (obj.gameDrawBox.left) * core.domStyle.scale + "px";

		// resize bigmap
		core.bigmap.canvas.forEach(function (cn) {
			const ratio = core.canvas[cn].canvas.hasAttribute('isHD') ? core.domStyle.ratio : 1;
			core.canvas[cn].canvas.style.width = core.canvas[cn].canvas.width / ratio * core.domStyle.scale + "px";
			core.canvas[cn].canvas.style.height = core.canvas[cn].canvas.height / ratio * core.domStyle.scale + "px";
		});
		// resize dynamic canvas
		for (const name in core.dymCanvas) {
			const ctx = core.dymCanvas[name],
				canvas = ctx.canvas;
			const ratio = canvas.hasAttribute('isHD') ? core.domStyle.ratio : 1;
			canvas.style.width = canvas.width / ratio * core.domStyle.scale + "px";
			canvas.style.height = canvas.height / ratio * core.domStyle.scale + "px";
			canvas.style.left = parseFloat(canvas.getAttribute("_left")) * core.domStyle.scale + "px";
			canvas.style.top = parseFloat(canvas.getAttribute("_top")) * core.domStyle.scale + "px";
		}
		// resize next
		main.dom.next.style.width = main.dom.next.style.height = 5 * core.domStyle.scale + "px";
		main.dom.next.style.borderBottomWidth = main.dom.next.style.borderRightWidth = 4 * core.domStyle.scale + "px";

	}

	core.control.resize = function () {
		if (main.mode == 'editor') return;

		const clientWidth = main.dom.body.clientWidth,
			clientHeight = main.dom.body.clientHeight;
		const canvasWidth = core.__PIXELS__;

		const isVertical = clientHeight > clientWidth;
		core.domStyle.isVertical = isVertical;

		const totalWidth = isVertical ? GAMEVIEW_WIDTH_VERTICAL : GAMEVIEW_WIDTH,
			totalHeight = isVertical ? GAMEVIEW_HEIGHT_VERTICAL : GAMEVIEW_HEIGHT;

		const maxRatio = Math.min(clientWidth / totalWidth, clientHeight / totalHeight);

		core.domStyle.availableScale = [];
		[1, 1.25, 1.5, 1.75, 2].forEach(function (v) {
			if (maxRatio >= v) {
				core.domStyle.availableScale.push(v);
			}
		});

		if (core.domStyle.availableScale.indexOf(core.domStyle.scale) < 0) {
			core.domStyle.scale = Math.min(1, maxRatio);
		} else if (core.getLocalStorage('scale') == null && core.domStyle.availableScale.length >= 2) {
			core.domStyle.scale = core.domStyle.availableScale[core.domStyle.availableScale.length - 2];
			core.setLocalStorage('scale', core.domStyle.scale);
		}

		const totalWidthScaled = totalWidth * core.domStyle.scale,
			totalHeightScaled = totalHeight * core.domStyle.scale;

		const gameDrawBox = isVertical ? { left: BORDER_WIDTH, top: BAR_HEIGHT_VERTICAL + BORDER_HEIGHT } : { left: BAR_WIDTH + BORDER_WIDTH, top: BORDER_HEIGHT };

		const obj = {
			clientWidth: clientWidth,
			clientHeight: clientHeight,
			canvasWidth: canvasWidth,
			totalWidth: totalWidthScaled,
			totalHeight: totalHeightScaled,
			gameDrawBox: gameDrawBox,
			globalAttribute: core.status.globalAttribute || core.initStatus.globalAttribute,
		};

		_resize_gameGroup(obj);
		_resize_canvas(obj);

		if (core.status.automaticRoute == null) core.status.automaticRoute = {};
		core.control.setViewport(32, 32);
		core.updateStatusBar();
	}

	class StatusBar {
		constructor() {
			this.itemMx = [
				["book", "wand", "fly"],
				["cross", "superPotion", "pickaxe"],
				["bomb", "centerFly", "upFly"],
				["downFly", "knife", "snow"],
				["bigKey", "earthquake", "coin"],
			];
		}
		init() {
			this.toolbarAction = [
				[main.core.openKeyBoard, main.core.openQuickShop, function () { core.insertAction([{ type: "insert", name: "游戏说明" }]); } ],
				[main.core.save, main.core.load, main.core.openSettings]
			];
			this.replayAction = [
				[core.triggerReplay, core.stopReplay, core.rewindReplay],
				[core.speedDownReplay, core.speedUpReplay, core.saveReplay]
			];
		}
		update() {
			this._update_background();
			this._update_props();
			this._update_items();
			this._update_equips();
			this._update_keys();
			this._update_infoWindow();
			this._update_infoBar();
		}
		_update_background(updatedFloorTitle) {
			const bgctx = main.dom.outerBackground.getContext("2d");
			const uictx = main.dom.outerUI.getContext("2d");
			if (core.domStyle.isVertical) {
				bgctx.canvas.width = GAMEVIEW_WIDTH_VERTICAL;
				bgctx.canvas.height = GAMEVIEW_HEIGHT_VERTICAL;
				uictx.canvas.width = GAMEVIEW_WIDTH_VERTICAL;
				uictx.canvas.height = GAMEVIEW_HEIGHT_VERTICAL;
				const bg = core.material.images.images["statusBackground_vertical.png"];
				bgctx.drawImage(bg, 0, 0, GAMEVIEW_WIDTH_VERTICAL, GAMEVIEW_HEIGHT_VERTICAL);
				core.setTextAlign('outerUI', 'center');
			} else {
				bgctx.canvas.width = GAMEVIEW_WIDTH;
				bgctx.canvas.height = GAMEVIEW_HEIGHT;
				uictx.canvas.width = GAMEVIEW_WIDTH;
				uictx.canvas.height = GAMEVIEW_HEIGHT;
				const bg = core.material.images.images["statusBackground.jpg"];
				bgctx.drawImage(bg, 0, 0, GAMEVIEW_WIDTH, GAMEVIEW_HEIGHT - INFO_BAR_HEIGHT);
				bgctx.fillStyle = "#676767";
				bgctx.fillRect(0, INFO_BAR_TOP, GAMEVIEW_WIDTH, INFO_BAR_HEIGHT);
				core.setTextAlign('outerUI', 'center');
			}
		}
		// 更新属性
		_update_props(updatedFloorTitle) {
			if (!updatedFloorTitle && core.status.floorId) {
				updatedFloorTitle = core.status.maps[core.status.floorId].title;
			}
			const statusList = ['hp', 'atk', 'def', 'money'];
			const drawStatusList = (baseX, baseY) => {
				let curh = baseY;
				core.setTextAlign('outerUI', 'right');
				statusList.forEach((item) => {
					// 四舍五入
					core.status.hero[item] = Math.round(core.status.hero[item]);
					// 大数据格式化
					core.fillText("outerUI", core.getRealStatus(item), baseX, curh, TEXT_COLOR);
					curh += 24;
				});
				core.setTextAlign('outerUI', 'center');
			};
			if (core.domStyle.isVertical) {
				core.clearMap("outerUI", 10, 0, 105, 120);
				core.setFont("outerUI", 'bold 14px Verdana');
				if (updatedFloorTitle) {
					core.fillText("outerUI", updatedFloorTitle, 54, 22, TEXT_COLOR);
				}
				drawStatusList(96, 46);
			} else {
				core.clearMap("outerUI", 10, 40, 105, 130);
				core.setFont("outerUI", 'bold 16px Verdana');
				if (updatedFloorTitle) {
					core.fillText("outerUI", updatedFloorTitle, 62, 61, TEXT_COLOR);
				}
				drawStatusList(110, 93);
			}
		}
		_update_items(){
			const drawItemMx = (drawFn) => {
				for (let i = 0; i < this.itemMx.length; i++) {
					for (let j = 0; j < this.itemMx[i].length; j++) {
						var item = this.itemMx[i][j];
						drawFn(i, j, item);
					}
				}
			};
			const drawItem = (item, posx, posy) => {
				const icon = core.material.icons.items[item], image = core.material.images.items;
				core.drawImage('outerUI', image, 0, 32 * icon, 32, 32, posx, posy, 32, 32);
				const cnt = core.itemCount(item);
				if ((core.items.items[item].cls === "tools" && cnt > 1) || FORCE_COUNTABLE_ITEMS.includes(item)) {
					core.fillText('outerUI', cnt, posx + 25, posy + 28, '#FFFFFF', "bold 12px Verdana");
				}
				// if (this.selectId == item)
				//     core.strokeRect('outerUI', posx + 17, posy - 4, 40, 40, '#FFD700');
			}
			if (core.domStyle.isVertical) {
				core.clearMap("outerUI", ITEM_BOX_LEFT_VERTICAL, ITEM_BOX_TOP_VERTICAL, 105, 185);
				drawItemMx((i, j, item) => {
					if (core.hasItem(item)) {
						const posx = ITEM_BOX_LEFT_VERTICAL + i * 33, posy = ITEM_BOX_TOP_VERTICAL + j * 32;
						drawItem(item, posx, posy);
					}
				});
			} else {
				core.clearMap("outerUI", ITEM_BOX_LEFT, ITEM_BOX_TOP, 105, 185);
				drawItemMx((i, j, item) => {
					if (core.hasItem(item)) {
						const posx = ITEM_BOX_LEFT + j * 33, posy = ITEM_BOX_TOP + i * 32;
						drawItem(item, posx, posy);
					}
				});
			}
		}
		_update_equips() {
			core.setFont("outerUI", 'bold 16px Verdana');
			const drawEquip = (baseX, baseY, id, color, back) => {
				if (!id) core.fillText("outerUI", back, baseX + 50, baseY + 22, color);
				else {
					core.fillText("outerUI", core.material.items[id].name, baseX + 32, baseY + 22, color);
					var icon = core.material.icons.items[id];
					core.drawImage('outerUI', core.material.images.items, 0, 32 * icon, 32, 32, baseX + 64, baseY, 32, 32);
				}
			};
			if (core.domStyle.isVertical) {
				core.clearMap("outerUI", EQUIP_BLOCK_LEFT_VERTICAL, EQUIP_BLOCK_TOP_VERTICAL, 105, 95);
				drawEquip(EQUIP_BLOCK_LEFT_VERTICAL, EQUIP_BLOCK_TOP_VERTICAL + 9, core.getFlag("nowWeapon"), "#FFCFAE", "无武器");
				drawEquip(EQUIP_BLOCK_LEFT_VERTICAL, EQUIP_BLOCK_TOP_VERTICAL + 49, core.getFlag("nowShield"), "#D1CEFF", "无防具");
			} else {
				core.clearMap("outerUI", EQUIP_BLOCK_LEFT, EQUIP_BLOCK_TOP, 105, 95);
				drawEquip(EQUIP_BLOCK_LEFT, EQUIP_BLOCK_TOP + 8, core.getFlag("nowWeapon"), "#FFCFAE", "无武器");
				drawEquip(EQUIP_BLOCK_LEFT, EQUIP_BLOCK_TOP + 56, core.getFlag("nowShield"), "#D1CEFF", "无防具");
			}
		}
		_update_keys() {
			const drawKeyList = (baseX, baseY, lines, rows) => {
				const todraw = [],
					keyList = ['yellowKey', 'blueKey', 'redKey', 'greenKey'];
				let total = 0;
				keyList.forEach(function (key, i) {
					todraw[i] = core.itemCount(key);
					total += todraw[i];
				});
				if (total > lines * rows) {
					let dn = 3;
					for (let i = 0; i <= dn; i++) {
						let deltaX = i * 26,
							deltaY = parseInt((lines - 1) / 2 * 14);
						this.drawKey(keyList[i], baseX + deltaX - 4, baseY + deltaY);
						core.setFont("outerUI", 'bold 12px Verdana');
						core.setTextAlign("outerUI", "left");
						core.fillText("outerUI", todraw[i], baseX + deltaX + 6, baseY + deltaY + 20, TEXT_COLOR);
					}
				} else {
					let dn = 3,
						dc = 0;
					while (dn >= 0 && dc < lines * rows) {
						if (todraw[dn]) {
							this.drawKey(keyList[dn], baseX + (dc % rows) * 14, baseY + parseInt(dc / rows) * 17);
							todraw[dn]--, dc++;
						} else dn--;
					}
				}
			};
			if (core.domStyle.isVertical) {
				core.clearMap("outerUI", KEY_BLOCK_LEFT_VERTICAL, KEY_BLOCK_TOP_VERTICAL, 105, 75);
				drawKeyList(KEY_BLOCK_LEFT_VERTICAL + 3, KEY_BLOCK_TOP_VERTICAL + 2, 2, 7);
			} else {
				core.clearMap("outerUI", KEY_BLOCK_LEFT, 140, 105, 75);
				drawKeyList(KEY_BLOCK_LEFT + 3, 142, 4, 7);
			}
		}
		drawKey(key, x, y) {
			let sx = 3,
				sy = 0;
			if (key == "blueKey") sx += 16;
			else if (key == "yellowKey") sy += 16;
			else if (key == "greenKey") { sx += 16;
				sy += 16; }
			core.drawImage("outerUI", core.statusBar.icons.keys, sx, sy, 10, 16, x, y, 10, 16);
		}
		_update_infoWindow() {
			const itemId = this.selectedItem;
			if (core.domStyle.isVertical) {
				core.clearMap("outerUI", INFO_BLOCK_LEFT_VERTICAL, INFO_BLOCK_TOP_VERTICAL, 260, 64);
				if (this.selectedItem) {
					const icon = core.material.icons.items[itemId];
					core.fillText("outerUI", core.material.items[itemId].name, INFO_BLOCK_LEFT_VERTICAL + 32, INFO_BLOCK_TOP_VERTICAL + 35, "#D1CEFF");
					core.drawImage('outerUI', core.material.images.items, 0, 32 * icon, 32, 32, INFO_BLOCK_LEFT_VERTICAL + 64, INFO_BLOCK_TOP_VERTICAL + 15, 32, 32);
					core.ui.drawTextContent("outerUI", core.material.items[itemId].text, {
						left: INFO_BLOCK_LEFT_VERTICAL + 100,
						top: INFO_BLOCK_TOP_VERTICAL + 3,
						maxWidth: 160,
						color: "#D1CEFF"
					});
				}
			} else {
				core.clearMap("outerUI", INFO_BLOCK_LEFT, INFO_BLOCK_TOP, 105, 100);
				if (this.selectedItem) {
					const icon = core.material.icons.items[itemId];
					core.fillText("outerUI", core.material.items[itemId].name, INFO_BLOCK_LEFT + 32, INFO_BLOCK_TOP + 25, "#D1CEFF");
					core.drawImage('outerUI', core.material.images.items, 0, 32 * icon, 32, 32, INFO_BLOCK_LEFT + 64, INFO_BLOCK_TOP + 4, 32, 32);
					core.ui.drawTextContent("outerUI", core.material.items[itemId].text, {
						left: INFO_BLOCK_LEFT + 1,
						top: INFO_BLOCK_TOP + 36,
						maxWidth: 105,
						color: "#D1CEFF"
					});
				}
			}
		}
		showItemInfo(itemId) {
			this.selectedItem = itemId;
			this._update_infoWindow();
		}
		clearItemInfo() {
			this.selectedItem = null;
			this._update_infoWindow();
		}
		_update_toolBox() {
			const tools = core.isReplaying() ?
				[
					[core.status.replay.pausing ? "play" : "pause", "stop", "rewind"],
					["speedDown", "speedUp", "save"],
				] : [
					["keyboard", "shop", "help"],
					["save", "load", "settings"],
				];
			if (core.domStyle.isVertical) {
				core.clearMap("outerUI", TOOL_BOX_LEFT_VERTICAL, TOOL_BOX_TOP_VERTICAL, 115, 80);
				for (let i = 0; i < tools.length; i++) {
					for (let j = 0; j < tools[i].length; j++) {
						core.drawIcon("outerUI", tools[i][j], TOOL_BOX_LEFT_VERTICAL + j * 34, TOOL_BOX_TOP_VERTICAL + i * 34, 32, 32);
					}
				}
			} else {
				core.clearMap("outerUI", TOOL_BOX_LEFT, TOOL_BOX_TOP, 115, 80);
				for (let i = 0; i < tools.length; i++) {
					for (let j = 0; j < tools[i].length; j++) {
						core.drawIcon("outerUI", tools[i][j], TOOL_BOX_LEFT + j * 34, TOOL_BOX_TOP + i * 34, 32, 32);
					}
				}
			}
		}
		onclick(x, y) {
			const makeBox = ([x, y], [w, h]) => {
				return [[x, y], [x + w, y + h]];
			}
			const gridify = ([x, y], [gw, gh]) => {
				return [parseInt(x / gw), parseInt(y / gh)];
			}
			const useItem = (itemId) => {
				if (!core.hasItem(itemId)) return;
				if (core.material.items[itemId].cls == "constants") {
					switch (itemId) {
						case "book":
							core.openBook(true);
							break;
						case "fly":
							core.useFly(true);
							break;
						case "wand":
							core.useItem("wand");
							break;
						case "snow":
							core.useItem("snow");
							break;
						default:
							this.showItemInfo(itemId);
					}
				} else if (itemId != this.selectedItem) {
					this.showItemInfo(itemId);
				} else {
					switch (itemId) {
						case "centerFly":
							core.ui._drawCenterFly();
							break;
						default:
							core.useItem(itemId);
					}
				}
			}
			const inRect = ([x, y], [[sx, sy], [dx, dy]]) => {
				return sx <= x && x <= dx && sy <= y && y <= dy;
			};
			const relativeTo = ([x, y], [ax, ay]) => {
				return [x - ax, y - ay];
			}
			const pos = [x, y];
			if (core.domStyle.isVertical) {
				const itemBox = makeBox([ITEM_BOX_LEFT_VERTICAL, ITEM_BOX_TOP_VERTICAL], [32 * 5, 33 * 3]);
				if (inRect(pos, itemBox)) {
					if (core.isReplaying() || core.status.lockControl || core.isMoving()) return;
					const [gx, gy] = gridify(relativeTo(pos, itemBox[0]), [32, 33]);
					const itemId = this.itemMx[gx][gy];
					useItem(itemId);
					return;
				}
				const toolBox = makeBox([TOOL_BOX_LEFT_VERTICAL, TOOL_BOX_TOP_VERTICAL], [34 * 3, 34 * 2]);
				if (inRect(pos, toolBox)) {
					const [row, col] = gridify(relativeTo(pos, toolBox[0]), [34, 34]);
					if (core.isReplaying()) {
						this.replayAction[col][row].call(core);
					} else if (core.isPlaying()) {
						this.toolbarAction[col][row].call(core, true);
					}
					return;
				}
			} else {
				const itemBox = makeBox([ITEM_BOX_LEFT, ITEM_BOX_TOP], [33 * 3, 32 * 5]);
				if (inRect(pos, itemBox)) {
					if (core.isReplaying() || core.status.lockControl || core.isMoving()) return;
					const [gx, gy] = gridify(relativeTo(pos, itemBox[0]), [33, 32]);
					const itemId = this.itemMx[gy][gx];
					useItem(itemId);
					return;
				}
				const toolBox = makeBox([TOOL_BOX_LEFT, TOOL_BOX_TOP], [34 * 3, 34 * 2]);
				if (inRect(pos, toolBox)) {
					const [row, col] = gridify(relativeTo(pos, toolBox[0]), [34, 34]);
					if (core.isReplaying()) {
						this.replayAction[col][row].call(core);
					} else if (core.isPlaying()) {
						this.toolbarAction[col][row].call(core, true);
					}
					return;
				}
			}
		}
		infoText;
		infocnt = 0;
		_update_infoBar() {
			core.setTextAlign('outerUI', 'left');
			const text = this.infoText;
			if (core.domStyle.isVertical) {
				core.clearMap("outerUI", 0, INFO_BAR_TOP_VERTICAL, GAMEVIEW_WIDTH, INFO_BAR_HEIGHT_VERTICAL);
				core.setFont("outerUI", 'bold 14px Verdana');
				if (text) {
					core.fillText("outerUI", text, 10, INFO_BAR_TOP_VERTICAL + 14, TEXT_COLOR);
				}
			} else {
				core.clearMap("outerUI", 0, INFO_BAR_TOP, GAMEVIEW_WIDTH, INFO_BAR_HEIGHT);
				core.setFont("outerUI", 'bold 16px Verdana');
				if (text) {
					core.fillText("outerUI", text, 10, INFO_BAR_TOP + 16, TEXT_COLOR);
				}
			}
			core.setTextAlign('outerUI', 'center');
		}
		print(text, cnt = 1) {
			this.infoText = text;
			this.infocnt = cnt;
			this._update_infoBar();
		}
		static infoRules = [
			{ id: "lava", text: "岩浆好热啊!" },
			{ id: "upFloor", text: "你看到了楼梯" },
			{ id: "downFloor", text: "你看到了楼梯" },
			{ id: "blueShop", text: "你看到了一个祭坛" },
			{ id: "man", text: "你看到了一个老人" },
			{ id: "woman", text: "你看到了一个商人" },
			{ id: "fairy", text: "你看到了一个商人" },
			{ id: "thief", text: "你看到了一个小偷" },
		]
		printEnvironmentInfo() {
			if (!this.infocnt) {
				return;
			}
			const ids = [];
			for (const block of core.status.thisMap.blocks) {
				if (!block.disable && core.nearHero(block.x, block.y)) ids.push(block.event.id);
			}
			for (const infoRule of StatusBar.infoRules) {
				if (ids.indexOf(infoRule.id) >= 0) {
					this.print(infoRule.text);
					return;
				}
			}
		}
		clearInfo(etype) {
			this.clearItemInfo();
			if (this.infocnt == 1) {
				setTimeout(() => {
					if (this.infocnt === 0) {
						this.infoText = void 0;
						this._update_infoBar();
					}
				}, 200);
				this.infocnt = 0;
			} else if (this.infocnt > 1) {
				this.infocnt--;
			}
		}
	}

	core.ui.statusBar = new StatusBar();

	core.control.clearStatusBar = function () {
		core.clearMap("outerUI");
	}
	// init() called in `afterLoadResources`.
},
    "override": function () {

	core.statusBar.icons = {
		'floor': 0,
		'name': null,
		'lv': 1,
		'hpmax': 2,
		'hp': 3,
		'atk': 4,
		'def': 5,
		'mdef': 6,
		'money': 7,
		'experience': 8,
		'up': 9,
		'book': 10,
		'fly': 11,
		'toolbox': 12,
		'keyboard': 13,
		'shop': 14,
		'save': 15,
		'load': 16,
		'settings': 17,
		'play': 18,
		'pause': 19,
		'stop': 20,
		'speedDown': 21,
		'speedUp': 22,
		'rewind': 23,
		'equipbox': 24,
		'mana': 25,
		'skill': 26,
		'paint': 27,
		'erase': 28,
		'empty': 29,
		'exit': 30,
		'btn1': 31,
		'btn2': 32,
		'btn3': 33,
		'btn4': 34,
		'btn5': 35,
		'btn6': 36,
		'btn7': 37,
		'btn8': 38,
		'keys': 39,
		'help': 40,
		'battle': 41
	};

	core.actions._clickCenterFly = function (x, y) {
		var posX = core.status.event.data.posX,
			posY = core.status.event.data.posY;
		core.ui.closePanel();
		if (x == posX && y == posY) {
			if (core.canUseItem('centerFly')) {
				core.useItem('centerFly');
			} else {
				core.drawTip('当前不能使用中心对称飞行器');
			}
		} else core.drawTip('取消使用');
	}

	var _clickSL = core.actions._clickSL;
	core.actions._clickSL = function (x, y) {
		var page = core.status.event.data.page,
			offset = core.status.event.data.offset;
		var index = page * 10 + offset;

		// 上一页
		if ((x == this.HSIZE - 1 || x == this.HSIZE - 2) && y == this.LAST) {
			core.ui._drawSLPanel(10 * (page - 1) + offset);
			return;
		}
		// 下一页
		if ((x == this.HSIZE + 1 || x == this.HSIZE + 2) && y == this.LAST) {
			core.ui._drawSLPanel(10 * (page + 1) + offset);
			return;
		}
		if ((x == this.HSIZE - 3 || x == this.HSIZE + 3) && y == this.LAST) {
			return;
		}
		_clickSL.call(this, x, y);
	}

	var _sys_longClick_lockControl = core.actions._sys_longClick_lockControl;
	core.actions._sys_longClick_lockControl = function (x, y) {
		if (!core.status.lockControl) return false;

		// 长按SL上下页快速翻页
		if (["save", "load", "replayLoad", "replayRemain"].indexOf(core.status.event.id) >= 0) {
			if (y == this.LAST && x <= this.HSIZE + 3 && x >= this.HSIZE - 3) {
				core.actions._clickSL(x, y);
				return true;
			}
		}
		return _sys_longClick_lockControl.call(this, x, y);
	}
	core.registerAction('longClick', '_sys_longClick_lockControl', core.actions._sys_longClick_lockControl, 50);

	core.control._moveHero_moving = function () {
		core.status.heroStop = false;
		core.status.automaticRoute.moveDirectly = false;
		var move = function () {
			if (!core.status.heroStop) {
				if (core.hasFlag('debug') && core.status.ctrlDown) {
					if (core.status.heroMoving != 0) return;
					// 检测是否穿出去
					var nx = core.nextX(),
						ny = core.nextY();
					if (nx < 1 || nx >= core.bigmap.width - 1 || ny < 1 || ny >= core.bigmap.height - 1) return;
					core.eventMoveHero([core.getHeroLoc('direction')], core.values.moveSpeed, move);
				} else {
					core.moveAction();
					setTimeout(move, 50);
				}
			}
		}
		move();
	}

	core.control._drawHero_updateViewport = function (x, y, offset) {}

	var _drawThumbnail_drawTempCanvas = core.maps._drawThumbnail_drawTempCanvas;
	core.maps._drawThumbnail_drawTempCanvas = function (floorId, blocks, options) {
		if (main.mode == 'editor') {
			_drawThumbnail_drawTempCanvas.call(this, floorId, blocks, options);
			return;
		}

		var width = core.floors[floorId].width;
		var height = core.floors[floorId].height;
		// 绘制到tempCanvas上面
		var tempCanvas = core.bigmap.tempCanvas;
		options.v2 = false;
		tempCanvas.canvas.width = width * 32;
		tempCanvas.canvas.height = height * 32;
		options.ctx = tempCanvas;

		var hasHero = core.status.hero != null,
			flags = null;
		if (options.flags) {
			if (!hasHero) core.status.hero = {};
			flags = core.status.hero.flags;
			core.status.hero.flags = options.flags;
		}
		this._drawThumbnail_realDrawTempCanvas(floorId, blocks, options);

		if (!hasHero) delete core.status.hero;
		else if (flags != null) core.status.hero.flags = flags;
		tempCanvas.setTransform(1, 0, 0, 1, 0, 0);
	}

	var _drawThumbnail_drawToTarget = core.maps._drawThumbnail_drawToTarget;
	core.maps._drawThumbnail_drawToTarget = function (floorId, options) {
		if (main.mode == 'editor') {
			_drawThumbnail_drawToTarget.call(this, floorId, options);
			return;
		}

		var ctx = core.getContextByName(options.ctx);
		if (ctx == null) return;
		var x = options.x || 0,
			y = options.y || 0,
			size = options.size || core.__PIXELS__;
		var tempCanvas = core.bigmap.tempCanvas;
		core.drawImage(ctx, tempCanvas.canvas, 32, 32, core.__PIXELS__, core.__PIXELS__, x, y, size, size);
	}

	var _drawWindowSkin = core.ui.drawWindowSkin;
	core.ui.drawWindowSkin = function (background, ctx, x, y, w, h, direction, px, py) {
		_drawWindowSkin.call(this, background, ctx, x, y, w, h, direction, px, py);

		var c = parseInt(w / 2);
		core.drawImage(ctx, background, 160, 90, 16, 6, x + c - 8, y, 16, 6);
	}

	var _drawPagination = ui.prototype.drawPagination;
	core.ui.drawPagination = function (page, totalPage, y) {
		if (["save", "load", "replayLoad", "replayRemain", "replaySince"].indexOf(core.status.event.id) >= 0) {
			if (totalPage <= 1) return;
			if (y == null) y = this.LAST;

			core.setFillStyle('ui', '#DDDDDD');
			var length = core.calWidth('ui', page, this._buildFont(15, true));

			core.setTextAlign('ui', 'left');
			core.fillText('ui', page, parseInt((this.PIXEL - length) / 2), y * 32 + 19);

			core.setTextAlign('ui', 'center');
			if (page > 1)
				core.fillText('ui', '上一页', this.HPIXEL - 48, y * 32 + 19);
			if (page < totalPage)
				core.fillText('ui', '下一页', this.HPIXEL + 48, y * 32 + 19);
			return;
		}
		_drawPagination.call(this, page, totalPage, y);
	}

	core.ui._drawCenterFly = function () {
		core.lockControl();
		core.status.event.id = 'centerFly';
		var fillstyle = 'rgba(255,0,0,0.5)';
		if (core.canUseItem('centerFly')) fillstyle = 'rgba(0,255,0,0.5)';
		var toX = core.bigmap.width - 1 - core.getHeroLoc('x'),
			toY = core.bigmap.height - 1 - core.getHeroLoc('y');
		this.clearUI();
		core.fillRect('ui', 0, 0, this.PIXEL, this.PIXEL, '#000000');
		core.drawThumbnail(null, null, { heroLoc: core.status.hero.loc, heroIcon: core.status.hero.image, ctx: 'ui', centerX: toX, centerY: toY });
		var offsetX = 1,
			offsetY = 1;
		core.fillRect('ui', (toX - offsetX) * 32, (toY - offsetY) * 32, 32, 32, fillstyle);
		core.status.event.data = { "x": toX, "y": toY, "posX": toX - offsetX, "posY": toY - offsetY };
		core.playSound('打开界面');
		core.drawTip("请确认当前" + core.material.items['centerFly'].name + "的位置", 'centerFly');
		return;
	}

	core.ui.drawHelp = function () {
		core.clearUI();
		core.status.event.id = 'help';
		core.lockControl();
		core.setAlpha('ui', 1);
		core.fillRect('ui', 0, 0, this.PIXEL, this.PIXEL, '#FFFFFF');
		core.drawImage('ui', core.material.images.keyboard, 0, 0, 416, 416, 0, 0, 352, 352);
	}

	core.actions._getClickLoc = function (x, y) {
		var size = 32 * core.domStyle.scale;
		var left = main.dom.gameDraw.offsetLeft + main.dom.gameGroup.offsetLeft;
		var top = main.dom.gameDraw.offsetTop + main.dom.gameGroup.offsetTop;
		var loc = { 'x': Math.max(x - left, 0), 'y': Math.max(y - top, 0), 'size': size };
		return loc;
	}

	core.enemys.getDamageString = function (enemy, x, y, floorId) {
		if (typeof enemy == 'string') enemy = core.material.enemys[enemy];
		var damage = this.getDamage(enemy, x, y, floorId);

		var color = '#000000';

		if (damage == null) {
			damage = "???";
			color = '#FF2222';
		} else {
			if (core.hasFlag('addhp')) {
				if (damage < core.status.hero.hp) color = '#11FF11';
				else color = '#FF2222';
			} else if (damage <= 0) color = '#11FF11';
			else if (damage < core.status.hero.hp / 3) color = '#FFFFFF';
			else if (damage < core.status.hero.hp * 2 / 3) color = '#FFFF00';
			else if (damage < core.status.hero.hp) color = '#FF9933';
			else color = '#FF2222';

			damage = core.formatBigNumber(damage, true);
			if (core.enemys.hasSpecial(enemy, 19))
				damage += "+";
			if (core.enemys.hasSpecial(enemy, 21))
				damage += "-";
			if (core.enemys.hasSpecial(enemy, 11))
				damage += "^";
		}

		return {
			"damage": damage,
			"color": color
		};
	}

	core.ui._drawBook_drawDamage = function (index, enemy, offset, position) {
		core.setTextAlign('ui', 'center');
		var damage = enemy.damage,
			color = '#FFFF00';
		if (damage == null) {
			damage = '不可攻击';
			color = '#FF2222';
		}
		if (damage == 0) {
			damage = '无危险';
			color = '#11FF11';
		} else {
			if (damage >= core.status.hero.hp) color = '#FF2222';
			else if (damage >= core.status.hero.hp * 2 / 3) color = '#FF9933';
			else if (damage <= 0) color = '#11FF11';
			damage = core.formatBigNumber(damage);
			if (core.enemys.hasSpecial(enemy, 19)) damage += "+";
			if (core.enemys.hasSpecial(enemy, 21)) damage += "-";
			if (core.enemys.hasSpecial(enemy, 11)) damage += "^";
		}
		if (enemy.notBomb) damage += "[b]";
		core.fillText('ui', damage, offset, position, color, this._buildFont(13, true));
	}

	core.control.checkBlock = function () {
		var x = core.getHeroLoc('x'),
			y = core.getHeroLoc('y'),
			loc = x + "," + y;
		var damage = core.status.checkBlock.damage[loc];
		if (damage) {
			core.status.hero.hp -= damage;
			if (core.status.checkBlock.type[loc]["血网伤害"]) core.plugin.achieve("a297");
			if (core.status.checkBlock.type[loc]["领域伤害"]) core.plugin.achieve("a294");
			if (core.status.checkBlock.type[loc]["阻击伤害"]) core.plugin.achieve("a295");
			if (core.status.checkBlock.type[loc]["夹击伤害"]) core.plugin.achieve("a296");
			if (core.status.checkBlock.type[loc]["血网伤害"]) core.drawTip("受到 " + damage + " 点魔法伤害");
			else core.drawTip("你没有神圣盾不能防御，受到 " + damage + " 点魔法伤害");
			core.playSound('zone.mp3');
			this._checkBlock_disableQuickShop();
			core.status.hero.statistics.extraDamage += damage;
			if (core.status.hero.hp <= 0) {
				core.status.hero.hp = 0;
				core.updateStatusBar();
				core.events.lose();
				return;
			} else {
				core.updateStatusBar();
			}
		}
		this._checkBlock_ambush(core.status.checkBlock.ambush[loc]);
		this._checkBlock_repulse(core.status.checkBlock.repulse[loc]);
	}

	core.registerSystemEvent("man", function (data, callback) {
		var a = parseInt(core.status.floorId.substring(2));
		var b = core.nextX();
		var c = core.nextY();
		core.insertAction([
			{ "type": "insert", "name": "对话", "args": [a, b, c, 0] },
		]);
		//console.log(data);
		if (callback) callback();
	});

	core.registerSystemEvent("woman", function (data, callback) {
		var name = core.status.floorId + '@' + core.nextX() + '@' + core.nextY() + '@' + 'A';
		if (core.getFlag(name, 0) == 1) {
			var a = parseInt(core.status.floorId.substring(2));
			var b = core.nextX();
			var c = core.nextY();
			core.insertAction([
				{ "type": "insert", "name": "对话", "args": [a, b, c, 1] },
			]);
		} else {
			core.insertAction([
				{ "type": "insert", "name": "商人", "args": [0] },
			]);
		}
		//console.log(data);
		if (callback) callback();
	});

	core.registerSystemEvent("specialwall", function (data, callback) {
		if (data.event.id == 'whiteWall' || core.getFlag('talking') > 0) {
			core.insertAction({ 'type': 'openDoor', loc: [data.x, data.y] });
			if (data.event.id != 'whiteWall') {
				core.setFlag('end', 1);
			}
			core.setFlag('talking', 0); //穿墙之后不能再次穿墙
		}
		core.plugin.achieve('a405')
		if (callback) callback();
	});

	core.registerSystemEvent("fakeWall", function (data, callback) {
		if (data.event.id == 'blueWall') {
			core.insertAction([
				{ "type": "openDoor", loc: [data.x, data.y] },
			]);
		}
		//console.log(data);
		if (callback) callback();
	});

	core.ui._drawWindowSelector = function (background, x, y, w, h) {
		w = Math.round(w) + 48;
		h = Math.round(h);
		var ctx = core.ui.createCanvas("_selector", x - 24, y, w, h, 165);
		ctx.canvas.id = '';
		this._drawSelector(ctx, background, w, h);
	}

	core.ui._drawSelector = function (ctx, background, w, h, left, top) {
		left = left || 0;
		top = top || 0;
		ctx = this.getContextByName(ctx);
		if (!ctx) return;
		if (typeof background == 'string')
			background = core.material.images.images[background];
		if (!(background instanceof Image)) return;
		// badge
		ctx.drawImage(background, 132, 68, 24, 24, left + 4, top + 4, 24, 24);
		ctx.drawImage(background, 132, 68, 24, 24, w - left - 28, top + 4, 24, 24);
	}

	core.ui.drawTip = function (text, id, clear) {
		core.ui.statusBar.print(text);
	}

	core.ui.clearMap = function (name, x, y, width, height) {
		if (name == 'all') {
			for (var m in core.canvas) {
				core.canvas[m].clearRect(0, 0, core.bigmap.width * 32, core.bigmap.height * 32);
			}
			core.clearMap("outerUI");
			core.dom.gif.innerHTML = "";
			core.removeGlobalAnimate();
		} else {
			var ctx = this.getContextByName(name);
			if (ctx) ctx.clearRect(x || 0, y || 0, width || ctx.canvas.width, height || ctx.canvas.height);
		}
	}

	core.control._updateStatusBar_setToolboxIcon = function () {
		core.ui.statusBar._update_toolBox();
	}

	var _changeFloor_getInfo = core.events._changeFloor_getInfo;
	core.events._changeFloor_getInfo = function (floorId, stair, heroLoc, time) {
		var info = _changeFloor_getInfo.call(this, floorId, stair, heroLoc, time);
		if (info == null) return null;
		info.time = 0;
		info.origin = floorId;
		return info;
	}

	core.events._changeFloor_afterChange = function (info, callback) {
		if (!info.locked) core.unlockControl();
		core.status.replay.animate = false;
		core.events.afterChangeFloor(info.floorId);

		if (info.origin == ':before') core.ui.statusBar.print('走下了楼梯')
		else if (info.origin == ':next') core.ui.statusBar.print('登上了楼梯')
		if (callback) callback();
	}

	if (window.jsinterface && window.jsinterface.requestLandscape) {
		window.jsinterface.requestLandscape();
	}
},
    "shop": function () {
	// 【全局商店】相关的功能
	// 
	// 打开一个全局商店
	// shopId：要打开的商店id；noRoute：是否不计入录像
	this.openShop = function (shopId, noRoute) {
		var shop = core.status.shops[shopId];
		// Step 1: 检查能否打开此商店
		if (!this.canOpenShop(shopId)) {
			core.drawTip("该商店尚未开启");
			return false;
		}

		// Step 2: （如有必要）记录打开商店的脚本事件
		if (!noRoute) {
			core.status.route.push("shop:" + shopId);
		}

		// Step 3: 检查道具商店 or 公共事件
		if (shop.item) {
			if (core.openItemShop) {
				core.openItemShop(shopId);
			} else {
				core.playSound('操作失败');
				core.insertAction("道具商店插件不存在！请检查是否存在该插件！");
			}
			return;
		}
		if (shop.commonEvent) {
			core.insertCommonEvent(shop.commonEvent, shop.args);
			return;
		}

		_shouldProcessKeyUp = true;

		// Step 4: 执行标准公共商店    
		core.insertAction(this._convertShop(shop));
		return true;
	}

	////// 将一个全局商店转变成可预览的公共事件 //////
	this._convertShop = function (shop) {
		return [
			{ "type": "function", "function": "function() {core.addFlag('@temp@shop', 1);}" },
			{
				"type": "while",
				"condition": "true",
				"data": [
					// 检测能否访问该商店
					{
						"type": "if",
						"condition": "core.isShopVisited('" + shop.id + "')",
						"true": [
							// 可以访问，直接插入执行效果
							{ "type": "function", "function": "function() { core.plugin._convertShop_replaceChoices('" + shop.id + "', false) }" },
						],
						"false": [
							// 不能访问的情况下：检测能否预览
							{
								"type": "if",
								"condition": shop.disablePreview,
								"true": [
									// 不可预览，提示并退出
									{ "type": "playSound", "name": "操作失败" },
									"当前无法访问该商店！",
									{ "type": "break" },
								],
								"false": [
									// 可以预览：将商店全部内容进行替换
									{ "type": "tip", "text": "当前处于预览模式，无法使用" },
									{ "type": "function", "function": "function() { core.plugin._convertShop_replaceChoices('" + shop.id + "', true) }" },
								]
							}
						]
					}
				]
			},
			{ "type": "function", "function": "function() {core.addFlag('@temp@shop', -1);}" }
		];
	}

	this._convertShop_replaceChoices = function (shopId, previewMode) {
		var shop = core.status.shops[shopId];
		var choices = (shop.choices || []).filter(function (choice) {
			if (choice.condition == null || choice.condition == '') return true;
			try { return core.calValue(choice.condition); } catch (e) { return true; }
		}).map(function (choice) {
			var ableToBuy = core.calValue(choice.need);
			return {
				"text": choice.text,
				"icon": choice.icon,
				"color": ableToBuy && !previewMode ? choice.color : [153, 153, 153, 1],
				"action": ableToBuy && !previewMode ? [{ "type": "playSound", "name": "商店" }].concat(choice.action) : [
					{ "type": "playSound", "name": "操作失败" },
					{ "type": "tip", "text": previewMode ? "预览模式下不可使用" : "无法选择" }
				]
			};
		}).concat({ "text": "离开", "action": [{ "type": "playSound", "name": "取消" }, { "type": "break" }] });
		core.insertAction({ "type": "choices", "text": shop.text, "choices": choices });
	}

	/// 是否访问过某个快捷商店
	this.isShopVisited = function (id) {
		if (!core.hasFlag("__shops__")) core.setFlag("__shops__", {});
		var shops = core.getFlag("__shops__");
		if (!shops[id]) shops[id] = {};
		return shops[id].visited;
	}

	/// 当前应当显示的快捷商店列表
	this.listShopIds = function () {
		return Object.keys(core.status.shops).filter(function (id) {
			return core.isShopVisited(id) || !core.status.shops[id].mustEnable;
		});
	}

	/// 是否能够打开某个商店
	this.canOpenShop = function (id) {
		if (this.isShopVisited(id)) return true;
		var shop = core.status.shops[id];
		if (shop.item || shop.commonEvent || shop.mustEnable) return false;
		return true;
	}

	/// 启用或禁用某个快捷商店
	this.setShopVisited = function (id, visited) {
		if (!core.hasFlag("__shops__")) core.setFlag("__shops__", {});
		var shops = core.getFlag("__shops__");
		if (!shops[id]) shops[id] = {};
		if (visited) shops[id].visited = true;
		else delete shops[id].visited;
	}

	/// 能否使用快捷商店
	this.canUseQuickShop = function (id) {
		// 如果返回一个字符串，表示不能，字符串为不能使用的提示
		// 返回null代表可以使用

		// 检查当前楼层的canUseQuickShop选项是否为false
		if (core.status.thisMap.canUseQuickShop === false)
			return '当前楼层不能使用快捷商店。';
		return null;
	}

	var _shouldProcessKeyUp = true;

	/// 允许商店X键退出
	core.registerAction('keyUp', 'shops', function (keycode) {
		if (!core.status.lockControl || core.status.event.id != 'action') return false;
		if ((keycode == 13 || keycode == 32) && !_shouldProcessKeyUp) {
			_shouldProcessKeyUp = true;
			return true;
		}

		if (!core.hasFlag("@temp@shop") || core.status.event.data.type != 'choices') return false;
		var data = core.status.event.data.current;
		var choices = data.choices;
		var topIndex = core.actions._getChoicesTopIndex(choices.length);
		if (keycode == 88 || keycode == 27) { // X, ESC
			core.actions._clickAction(core.actions.HSIZE, topIndex + choices.length - 1);
			return true;
		}
		return false;
	}, 60);

	/// 允许长按空格或回车连续执行操作
	core.registerAction('keyDown', 'shops', function (keycode) {
		if (!core.status.lockControl || !core.hasFlag("@temp@shop") || core.status.event.id != 'action') return false;
		if (core.status.event.data.type != 'choices') return false;
		var data = core.status.event.data.current;
		var choices = data.choices;
		var topIndex = core.actions._getChoicesTopIndex(choices.length);
		if (keycode == 13 || keycode == 32) { // Space, Enter
			core.actions._clickAction(core.actions.HSIZE, topIndex + core.status.event.selection);
			_shouldProcessKeyUp = false;
			return true;
		}
		return false;
	}, 60);

	// 允许长按屏幕连续执行操作
	core.registerAction('longClick', 'shops', function (x, y, px, py) {
		if (!core.status.lockControl || !core.hasFlag("@temp@shop") || core.status.event.id != 'action') return false;
		if (core.status.event.data.type != 'choices') return false;
		var data = core.status.event.data.current;
		var choices = data.choices;
		var topIndex = core.actions._getChoicesTopIndex(choices.length);
		if (x >= core.actions.CHOICES_LEFT && x <= core.actions.CHOICES_RIGHT && y >= topIndex && y < topIndex + choices.length) {
			core.actions._clickAction(x, y);
			return true;
		}
		return false;
	}, 60);
},
    "道具血瓶显示": function () {
	/* 宝石血瓶左下角显示数值
	 * 需要将 变量：itemDetail改为true才可正常运行
	 * 请尽量减少勇士的属性数量，否则可能会出现严重卡顿（划掉，现在你放一万个属性也不会卡）
	 * 注意：这里的属性必须是core.status.hero里面的，flag无法显示
	 * 如果不想显示，可以core.setFlag("itemDetail", false);
	 * 然后再core.getItemDetail();
	 * 如有bug在大群或造塔群@古祠
	 */

	// 忽略的道具
	const ignore = ['superPotion'];

	// 取消注释下面这句可以减少超大地图的判定。
	// 如果地图宝石过多，可能会略有卡顿，可以尝试取消注释下面这句话来解决。
	// core.bigmap.threshold = 256;
	const origin = core.control.updateStatusBar;
	core.updateStatusBar = core.control.updateStatusBar = function () {
		if (core.getFlag('__statistics__')) return;
		else return origin.apply(core.control, arguments);
	}

	core.control.updateDamage = function (floorId, ctx) {
		floorId = floorId || core.status.floorId;
		if (!floorId || core.status.gameOver || main.mode != 'play') return;
		const onMap = ctx == null;

		// 没有怪物手册
		if (!core.hasItem('book')) return;
		core.status.damage.posX = core.bigmap.posX;
		core.status.damage.posY = core.bigmap.posY;
		if (!onMap) {
			const width = core.floors[floorId].width,
				height = core.floors[floorId].height;
			// 地图过大的缩略图不绘制显伤
			if (width * height > core.bigmap.threshold) return;
		}
		this._updateDamage_damage(floorId, onMap);
		this._updateDamage_extraDamage(floorId, onMap);
		core.getItemDetail(floorId); // 宝石血瓶详细信息
		//core.drawDoorDetail(floorId); // 门详细信息
		this.drawDamage(ctx);
	};
	// 获取宝石信息 并绘制
	this.getItemDetail = function (floorId) {
		if (!core.getFlag('itemDetail')) return;
		floorId = floorId === void 0 || floorId === null ? core.status.thisMap.floorId : floorId;
		let diff = {};
		const before = core.status.hero;
		const hero = core.clone(core.status.hero);
		const handler = {
			set: function (target, key, v) {
				diff[key] = v - (target[key] || 0);
				if (!diff[key]) diff[key] = void 0;
				return true;
			}
		};
		core.status.hero = new Proxy(hero, handler);
		core.status.maps[floorId].blocks.forEach(function (block) {
			if (
				block.event.cls !== 'items' ||
				ignore.includes(block.event.id) ||
				block.disable
			)
				return;
			const x = block.x,
				y = block.y;
			// v2优化，只绘制范围内的部分
			if (core.bigmap.v2) {
				if (
					x < core.bigmap.posX - core.bigmap.extend ||
					x > core.bigmap.posX + core._SIZE_ + core.bigmap.extend ||
					y < core.bigmap.posY - core.bigmap.extend ||
					y > core.bigmap.posY + core._SIZE_ + core.bigmap.extend
				) {
					return;
				}
			}
			diff = {};
			const id = block.event.id;
			const item = core.material.items[id];
			if (item.cls === 'equips') {
				// 装备也显示
				const diff = item.equip.value === void 0 || item.equip.value === null ? {} : item.equip.value;

				const per = item.equip.percentage === void 0 || item.equip.percentage === null ? {} : item.equip.percentage;
				for (const name in per) {
					diff[name + 'per'] = per[name].toString() + '%';
				}
				drawItemDetail(diff, x, y);
				return;
			}
			// 跟数据统计原理一样 执行效果 前后比较
			core.setFlag('__statistics__', true);
			try {
				eval(item.itemEffect);
			} catch (error) {}
			drawItemDetail(diff, x, y);
		});
		core.status.hero = before;
		window.hero = before;
		window.flags = before.flags;
	};


	this.drawDoorDetail = function (floorId) {
		//if (!core.getFlag('doorDetail')) return;
		floorId = floorId === void 0 || floorId === null ? core.status.thisMap.floorId : floorId;
		let diff = {};
		const before = core.status.hero;
		const hero = core.clone(core.status.hero);
		const handler = {
			set: function (target, key, v) {
				diff[key] = v - (target[key] || 0);
				if (!diff[key]) diff[key] = void 0;
				return true;
			}
		};
		core.status.hero = new Proxy(hero, handler);
		core.status.maps[floorId].blocks.forEach(function (block) {
			if ((block.id < 81) || (block.id > 83))
				return;
			const x = block.x,
				y = block.y;
			// v2优化，只绘制范围内的部分
			if (core.bigmap.v2) {
				if (
					x < core.bigmap.posX - core.bigmap.extend ||
					x > core.bigmap.posX + core._SIZE_ + core.bigmap.extend ||
					y < core.bigmap.posY - core.bigmap.extend ||
					y > core.bigmap.posY + core._SIZE_ + core.bigmap.extend
				) {
					return;
				}
			}
			core.setFlag('__statistics__', true);
			core.status.damage.data.push({
				text: block.id,
				px: 32 * x + 2,
				py: 32 * y + 30,
				color: '#FFFFFF'
			});
		});
		core.status.hero = before;
		window.hero = before;
		window.flags = before.flags;
	};

	// 绘制
	function drawItemDetail(diff, x, y) {
		const px = 32 * x + 2,
			py = 32 * y + 30;
		let content = '';
		// 获得数据和颜色
		let i = 0;
		for (const name in diff) {
			if (!diff[name]) continue;
			let color = '#fff';

			if (typeof diff[name] === 'number')
				content = core.formatBigNumber(diff[name], true);
			else content = diff[name];
			switch (name) {
			case 'atk':
			case 'atkper':
				color = '#FF7A7A';
				break;
			case 'def':
			case 'defper':
				color = '#00E6F1';
				break;
			case 'mdef':
			case 'mdefper':
				color = '#6EFF83';
				break;
			case 'hp':
				color = '#A4FF00';
				break;
			case 'hpmax':
			case 'hpmaxper':
				color = '#F9FF00';
				break;
			case 'mana':
				color = '#c66';
				break;
			}
			// 绘制
			core.status.damage.data.push({
				text: content,
				px: px,
				py: py - 10 * i,
				color: color
			});
			i++;
		}
	}

},
    "auto": function () {
	// 自动拾取和自动清怪二合一插件，根据插件库中“磁吸特效+自动拾取物品”和魔塔“纳可物语”中的自动清怪插件进行拼接和微调，清理重复部分
	// 两种功能分开跑bfs，性能不如插件库中的“玩家体验优化 --- 各种自动清”，但是道具后事件和战后事件都能正常触发
	// 使用hasFlag控制，两个flag分别是zdsq和autoBattle，可以在对应的控制开关处更改

	// 插件总开关，取消注释则禁用插件
	// return;

	////// 每移动一格后执行的事件 //////
	control.prototype.moveOneStep = function (callback) {
		if (core.status.floorId != 'MT49') {
			core.plugin.autoGetItem();
			core.plugin.autoBattle();
			core.plugin.autoGetItem();
			core.plugin.autoBattle();
		} else core.plugin.autoGetItem();
		return this.controldata.moveOneStep(callback);
	}

	function bfsFlood(sx, sy, blockfn) {
		const canMoveArray = core.generateMovableArray();
		const blocksObj = core.getMapBlocksObj();
		const bgMap = core.getBgMapArray();

		let visited = [],
			queue = [];
		visited[sx + "," + sy] = 0;
		queue.push(sx + "," + sy);

		while (queue.length > 0) {
			let now = queue.shift().split(","),
				x = ~~now[0],
				y = ~~now[1];
			for (let direction in core.utils.scan) {
				if (!core.inArray(canMoveArray[x][y], direction)) continue;
				const nx = x + core.utils.scan[direction].x,
					ny = y + core.utils.scan[direction].y,
					nindex = nx + "," + ny;
				if (visited[nindex]) continue;
				if (core.onSki(bgMap[ny][nx])) continue;
				if (blockfn && !blockfn(blocksObj, nx, ny)) continue;
				visited[nindex] = visited[now] + 1;
				queue.push(nindex);
			}
		}
	}

	// 需要同时拦截自动拾取和自动清怪的情况
	function intercept() {
		const loc_x = core.status.hero.loc.x,
			loc_y = core.status.hero.loc.y,
			loc_idx = loc_x + "," + loc_y;
		if (Object.keys(core.status.checkBlock.damage).indexOf(loc_idx) != -1 ||
			Object.keys(core.status.checkBlock.repulse).indexOf(loc_idx) != -1 ||
			Object.keys(core.status.checkBlock.ambush).indexOf(loc_idx) != -1 ||
			core.getBlockId(loc_x, loc_y) === "poisonNet" || core.getBlockId(loc_x, loc_y) === "weakNet" || core.getBlockId(loc_x, loc_y) === "curseNet" ||
			core.getBlockId(loc_x, loc_y) === "none" ||
			core.hasFlag('poison')) return true;
	}

	function attractAnimate() {
		var name = 'attractAnimate';
		var isPlaying = false;
		this.nodes = [];

		this.add = function (id, x, y, callback) {
			this.nodes.push({ id: id, x: x, y: y, callback: callback });
		}
		this.start = function () {
			if (isPlaying) return;
			isPlaying = true;
			core.registerAnimationFrame(name, true, this.update);
			this.ctx = core.createCanvas(name, 0, 0, core.__PIXELS__, core.__PIXELS__, 120);
		}
		this.remove = function () {
			core.unregisterAnimationFrame(name);
			core.deleteCanvas(name);
			isPlaying = false;
		}
		this.clear = function () {
			this.nodes = [];
			this.remove();
		}
		var lastTime = -1;
		var self = this;
		this.update = function (timeStamp) {
			if (lastTime < 0) lastTime = timeStamp;
			if (timeStamp - lastTime < 20) return;
			lastTime = timeStamp;
			core.clearMap(name);
			var cx = core.status.heroCenter.px - 48,
				cy = core.status.heroCenter.py - 48;
			var thr = 3; //缓动比例倒数 越大移动越慢
			self.nodes.forEach(function (n) {
				var dx = cx - n.x,
					dy = cy - n.y;
				if (Math.abs(dx) <= thr && Math.abs(dy) <= thr) {
					n.dead = true;
				} else {
					n.x += ~~(dx / thr);
					n.y += ~~(dy / thr);
				}
				core.drawIcon(name, n.id, n.x, n.y, 32, 32);
			});
			self.nodes = self.nodes.filter(function (n) {
				if (n.dead && n.callback) {
					n.callback();
				}
				return !n.dead;
			});
			if (self.nodes.length == 0)
				self.remove();
		}
	}


	var animateHwnd = new attractAnimate();

	this.stopAttractAnimate = function () {
		animateHwnd.clear();
	}

	// 自动拾取控制开关
	this.autoGetItem = function () {
		var canGetItems = {};
		if (intercept() ||
			!core.status.floorId || !core.status.checkBlock.damage || core.status.event.id == 'action' || core.status.lockControl ||
			!core.hasFlag('zdsq')) return;

		bfsFlood(core.getHeroLoc('x'), core.getHeroLoc('y'), function (blockMap, x, y) {
			var idx = x + ',' + y;
			if (idx in canGetItems) return false;
			var blk = blockMap[idx];
			if (blk && !blk.disable && blk.event.cls == 'items' && !core.isMapBlockDisabled(core.status.floorId, blk.x, blk.y) && blk.event.trigger == 'getItem') {
				canGetItems[idx] = { x: x, y: y, id: blk.event.id };
				return !core.status.checkBlock.damage[idx] && !core.status.checkBlock.ambush[idx];
			}
			return core.maps._canMoveDirectly_checkNextPoint(blockMap, x, y);
		});
		for (var k in canGetItems) {
			var x = canGetItems[k].x,
				y = canGetItems[k].y,
				id = canGetItems[k].id;
			core.trigger(x, y);
			animateHwnd.add(id, x * 32, y * 32);
		}
		animateHwnd.start();
	}

	control.prototype._replayAction_moveDirectly = function (action) {
		if (action.indexOf("move:") != 0) return false;
		// 忽略连续的瞬移事件；如果大地图某一边超过计算范围则不合并
		// if (!core.hasFlag('poison') && core.status.thisMap.width < 2 * core.bigmap.extend + core.__SIZE__
		//     && core.status.thisMap.height < 2 * core.bigmap.extend + core.__SIZE__) {
		//     while (core.status.replay.toReplay.length>0 &&
		//         core.status.replay.toReplay[0].indexOf('move:')==0) {
		//             core.status.route.push(action);
		//             action = core.status.replay.toReplay.shift();
		//     }
		// }

		var pos = action.substring(5).split(":");
		var x = parseInt(pos[0]),
			y = parseInt(pos[1]);
		var nowx = core.getHeroLoc('x'),
			nowy = core.getHeroLoc('y');
		var ignoreSteps = core.canMoveDirectly(x, y);
		if (!core.moveDirectly(x, y, ignoreSteps)) return false;
		if (core.status.replay.speed == 24) {
			core.replay();
			return true;
		}

		core.ui.drawArrow('ui', 32 * nowx + 16 - core.bigmap.offsetX, 32 * nowy + 16 - core.bigmap.offsetY,
			32 * x + 16 - core.bigmap.offsetX, 32 * y + 16 - core.bigmap.offsetY, '#FF0000', 3);
		var timeout = this.__replay_getTimeout();
		if (ignoreSteps < 10) timeout = timeout * ignoreSteps / 10;
		setTimeout(function () {
			core.clearMap('ui');
			core.replay();
		}, timeout);
		return true;
	}

	//
	////// 自动清怪 //////
	//

	core.control.registerReplayAction("moveDirectly", core.control._replayAction_moveDirectly);

	//战斗
	core.events.battle = function (id, x, y, force, callback) {
		core.saveAndStopAutomaticRoute();
		id = id || core.getBlockId(x, y);
		if (!id) return core.clearContinueAutomaticRoute(callback);
		// 非强制战斗
		if (!core.enemys.canBattle(id, x, y) && !force && !core.status.event.id) {
			core.stopSound();
			core.playSound('操作失败');
			core.plugin.achieve("a204");
			core.drawTip("你打不过此怪物！", id);
			return core.clearContinueAutomaticRoute(callback);
		}
		// 自动清怪时禁止自动存档
		var need_save = !core.status.event.id && !core.getFlag("disable_autosave2", 0);
		// 自动存档
		if (need_save) core.autosave(true);
		// 战前事件
		if (!this.beforeBattle(id, x, y))
			return core.clearContinueAutomaticRoute(callback);
		// 战后事件
		this.afterBattle(id, x, y);
		core.setFlag("disable_autosave", 0);
		if (callback) callback();
	}


	this.isEnemy = function (x, y) {
		return core.getBlockCls(x, y) === 'enemys' || core.getBlockCls(x, y) === 'enemy48';
	}

	// 战斗控制开关
	this.autoBattle = function () {
		if (intercept() ||
			core.status.floorId === 'MT2' ||
			core.hasItem('I361') || core.hasItem('I363') ||
			!core.hasFlag('autoBattle')) return;
		var canBattleEnemys = {};
		var index_list = []; // 保序
		var canBattleFunc = function (block, idx, x, y) {
			var blkid = block ? block.event.id : "";
			var result = block && !block.disable && core.plugin.isEnemy(x, y) && !core.isMapBlockDisabled(core.status.floorId, block.x, block.y) &&
				block.event.trigger == 'battle';
			if (!result) return false;
			var enemy = core.material.enemys[blkid];
			if (core.getDamage(blkid, x, y) == null || core.getDamage(blkid, x, y) > 0) return false;

			// 根据怪物特殊属性排除，可根据自身需求更改
			if (core.enemys.hasSpecial(blkid, 25) ||
				core.enemys.hasSpecial(blkid, 30) ||
				core.enemys.hasSpecial(blkid, 31) ||
				core.enemys.hasSpecial(blkid, 32) ||
				core.enemys.hasSpecial(blkid, 34) ||
				core.enemys.hasSpecial(blkid, 35) ||
				core.enemys.hasSpecial(blkid, 19) && !core.hasItem('cross')) return false;

			return true;
		}
		var blockfn = function (blockMap, x, y) {
			var idx = x + ',' + y;
			if (idx in canBattleEnemys) return false;
			var blk = blockMap[idx];

			if (canBattleFunc(blk, idx, x, y)) {
				canBattleEnemys[idx] = { x: x, y: y, id: blk.event.id };
				index_list.push(idx);
				return !core.status.checkBlock.damage[idx] && !core.status.checkBlock.repulse[idx] && !core.status.checkBlock.ambush[idx];
			}
			return core.maps._canMoveDirectly_checkNextPoint(blockMap, x, y);
		};
		if (!core.status.floorId || !core.status.checkBlock.damage || core.status.event.id == 'action' || core.status.lockControl) return;

		// 执行自动清怪
		bfsFlood(core.getHeroLoc('x'), core.getHeroLoc('y'), blockfn);

		// 处理存档
		core.setFlag("disable_autosave2", 1);
		for (var i = 0; i < index_list.length; ++i) {
			var k = index_list[i];
			var x = canBattleEnemys[k].x,
				y = canBattleEnemys[k].y,
				id = canBattleEnemys[k].id;
			if (core.plugin.isEnemy(x, y) && core.getDamage(id, x, y) <= 0) { // double check，比如打了某只暴戾之后本来0伤的怪突然非0了
				core.battle(id, x, y);
			}
		}
		core.setFlag("disable_autosave2", 0);
	}
},
    "成就": function () {
	// 
	// core.plugin.achievements[0] 可以调用a001对象
	// core.plugin.AchievementsFlags('a001',false);该语句可以判断对应成就是否达成，接收成就flag和索引数值。false改为true则不跟存档跟游戏
	// core.status.route.push("achievement:a001");该语句可以通过下方注册的录像行为单独将一个成就的达成推入录像，但绝大部分情况下不使用它录像也能生效
	// core.plugin.achieve("a001"); 达成a001对应的成就
	// 随机模式下，先使用core.plugin.randomreward()将随机奖励初始化，请确保初始化完成
	// 然后开启"随机快捷获取"flag便可以在每次达成成就时获得成就奖励,或者使用core.plugin.giveallreward()一次性获取所有奖励
	// 奖励获取的过程将使用公共事件来完成，请自行编写
	// 可以重新初始化随机奖励，这会导致玩家之前的获取记录被消除，可以获得额外的奖励
	this.hideachieve = 400; //用于判断普通成就和隐藏成就的分界线
	// 注册一个录像处理行为
	core.registerReplayAction('achievement', function (action) {
		if (action.indexOf('achievement:') === -1) return false;
		let a = action.split(":");
		if (!['a159', 'a160', 'a268', 'a269', 'a254', 'a255', 'a268', 'a269', 'a270', 'a272', 'a298', 'a343', 'a344'].includes(a[1])) return false; //该功能可以确保只有指定的成就能通过录像达成，可以避免作弊
		if (a[1] === 'a343' && core.status.floorId != 'MT25') return false;
		if (core.status.floorId != "ac" && a[1] === 'a344') return false;
		core.status.route.push(action);
		core.plugin.achieve(a[1]);
		core.replay();
		// 返回true表示我们已经成功处理了此录像行为。
		return true;
	});
	// 所有成就项的定义
	this.achievements = [
		// 每行一个，分别定义flag、名称、描述、是否存在提示、成就点数
		{ "flag": "a001", "name": "开始游戏", "text": "美好的第一次！", "hint": false, "point": 10 },
		{ "flag": "a002", "name": "学会走路", "text": "不然你是怎么来魔塔的？", "hint": false, "point": 2 },
		{ "flag": "a003", "name": "捡起道具", "text": "并不能证明你有手！", "hint": false, "point": 1 },
		{ "flag": "a004", "name": "进行交流", "text": "我看你这像素图上没嘴啊", "hint": false, "point": 1 },
		{ "flag": "a005", "name": "走上楼梯", "text": "用爬的", "hint": false, "point": 1 },
		{ "flag": "a006", "name": "走下楼梯", "text": "上山容易下山难", "hint": false, "point": 1 },
		{ "flag": "a007", "name": "选择模式", "text": "哪种更好玩呢？", "hint": false, "point": 1 },
		{ "flag": "a008", "name": "进入成就兑换店", "text": "我买故我在", "hint": false, "point": 1 },
		{ "flag": "a009", "name": "首次战斗", "text": "勇者的天职！", "hint": false, "point": 1 },
		{ "flag": "a010", "name": "受到战斗伤害", "text": "凡人之躯脆弱不堪", "hint": false, "point": 1 },
		{ "flag": "a011", "name": "获得怪物手册", "text": "信不信由你，这才是魔塔最强宝物", "hint": false, "point": 1 },
		{ "flag": "a012", "name": "获得记事本", "text": "惊不惊喜，意不意外", "hint": false, "point": 1 },
		{ "flag": "a013", "name": "获得楼层传送器", "text": "现代文明的附赠品", "hint": false, "point": 1 },
		{ "flag": "a014", "name": "获得十字架", "text": "不如义乌批发", "hint": false, "point": 5 },
		{ "flag": "a015", "name": "获得圣水", "text": "我去厕所给你倒杯圣水", "hint": false, "point": 5 },
		{ "flag": "a016", "name": "获得破墙镐", "text": "打不破第四面墙", "hint": false, "point": 4 },
		{ "flag": "a017", "name": "获得炸弹", "text": "你发明了烟花", "hint": false, "point": 6 },
		{ "flag": "a018", "name": "获得对称飞", "text": "谁规定了中心轴？", "hint": false, "point": 5 },
		{ "flag": "a019", "name": "获得上楼器", "text": "步步高升！", "hint": false, "point": 7 },
		{ "flag": "a020", "name": "获得下楼器", "text": "深入地心！", "hint": false, "point": 4 },
		{ "flag": "a021", "name": "获得屠龙匕首", "text": "不要变成龙", "hint": false, "point": 8 },
		{ "flag": "a022", "name": "获得冰冻徽章", "text": "世界上没有两片一样的冰冻徽章", "hint": false, "point": 8 },
		{ "flag": "a023", "name": "获得大黄门钥匙", "text": "全塔最魔幻的道具", "hint": false, "point": 5 },
		{ "flag": "a024", "name": "获得地震卷轴", "text": "拆除你所不需要的承重墙", "hint": false, "point": 10 },
		{ "flag": "a025", "name": "获得幸运金币", "text": "你也有币了", "hint": false, "point": 10 },
		{ "flag": "a026", "name": "获得黄钥匙", "text": "没有金币时可以用它代替", "hint": false, "point": 2 },
		{ "flag": "a027", "name": "获得蓝钥匙", "text": "蓝海塔必备", "hint": false, "point": 4 },
		{ "flag": "a028", "name": "获得红钥匙", "text": "看起来红是因为红移", "hint": false, "point": 8 },
		{ "flag": "a029", "name": "获得绿钥匙", "text": "海盐的味道", "hint": false, "point": 2 },
		{ "flag": "a030", "name": "获得铁门钥匙", "text": "凭什么我就需要它？", "hint": false, "point": 2 },
		{ "flag": "a031", "name": "获得红血瓶", "text": "格勒第倾情推荐", "hint": false, "point": 2 },
		{ "flag": "a032", "name": "获得蓝血瓶", "text": "节肢类的辉煌历史", "hint": false, "point": 4 },
		{ "flag": "a033", "name": "获得绿血瓶", "text": "没错，血就是这个颜色", "hint": false, "point": 6 },
		{ "flag": "a034", "name": "获得黄血瓶", "text": "可以让你变黄", "hint": false, "point": 8 },
		{ "flag": "a035", "name": "获得红宝石", "text": "和阳光相性很好", "hint": false, "point": 2 },
		{ "flag": "a036", "name": "获得蓝宝石", "text": "冰冻法杖的材料", "hint": false, "point": 2 },
		{ "flag": "a037", "name": "获得绿宝石", "text": "实际上是啤酒瓶底", "hint": false, "point": 3 },
		{ "flag": "a038", "name": "获得黄宝石", "text": "塔里只有两枚", "hint": false, "point": 4 },
		{ "flag": "a039", "name": "获得成就", "text": "你好呀", "hint": false, "point": 1 },
		{ "flag": "a040", "name": "获得过所有物品", "text": "真不愧是你", "hint": false, "point": 10 },
		{ "flag": "a041", "name": "获得铁剑", "text": "每个勇者的起点", "hint": false, "point": 2 },
		{ "flag": "a042", "name": "获得铁盾 ", "text": "步兵怎么不顶盾？", "hint": false, "point": 2 },
		{ "flag": "a043", "name": "获得银剑", "text": "正适合你练剑", "hint": false, "point": 4 },
		{ "flag": "a044", "name": "获得银盾", "text": "不是秘银的吗？", "hint": false, "point": 4 },
		{ "flag": "a045", "name": "获得骑士剑", "text": "嘿嘿错了，骑士可没用过我", "hint": false, "point": 6 },
		{ "flag": "a046", "name": "获得骑士盾", "text": "你以为你已经非常坚实了吗？", "hint": false, "point": 6 },
		{ "flag": "a047", "name": "获得圣剑", "text": "没有插在石头里真是太好了", "hint": false, "point": 8 },
		{ "flag": "a048", "name": "获得圣盾", "text": "你都保护了些什么啊", "hint": false, "point": 8 },
		{ "flag": "a049", "name": "获得神圣剑", "text": "被苦主NTR了黄毛的真女主", "hint": false, "point": 10 },
		{ "flag": "a050", "name": "获得神圣盾", "text": "这才算是完整的魔塔生涯", "hint": false, "point": 10 },
		{ "flag": "a051", "name": "获得所有种类武器", "text": "5刀流", "hint": false, "point": 10 },
		{ "flag": "a052", "name": "获得所有种类防具", "text": "这是神圣盾吗？", "hint": false, "point": 10 },
		{ "flag": "a053", "name": "和商人对话", "text": "塔里也有柴米油盐", "hint": false, "point": 2 },
		{ "flag": "a054", "name": "和老人对话", "text": "塔里也有人情世故", "hint": false, "point": 2 },
		{ "flag": "a055", "name": "和商店对话", "text": "塔里也有摩艾石像", "hint": false, "point": 2 },
		{ "flag": "a056", "name": "和牌子对话", "text": "对对对，我会说话", "hint": false, "point": 2 },
		{ "flag": "a057", "name": "和蓝象对话", "text": "请遵守规则", "hint": false, "point": 2 },
		{ "flag": "a058", "name": "向商人购买", "text": "没有钱是万万不能的", "hint": false, "point": 3 },
		{ "flag": "a059", "name": "向商店购买", "text": "通货膨胀害死人", "hint": false, "point": 3 },
		{ "flag": "a060", "name": "向老人购买", "text": "买了个寂寞", "hint": false, "point": 3 },
		{ "flag": "a061", "name": "对话所有商人", "text": "商群大迁徙", "hint": false, "point": 10 },
		{ "flag": "a062", "name": "对话所有老人", "text": "人去塔空", "hint": false, "point": 10 },
		{ "flag": "a063", "name": "获得金币", "text": "第一桶金", "hint": false, "point": 1 },
		{ "flag": "a064", "name": "获得100金币", "text": "启动资金", "hint": false, "point": 2 },
		{ "flag": "a065", "name": "获得1000金币", "text": "一把黄钥匙", "hint": false, "point": 5 },
		{ "flag": "a066", "name": "获得1万金币", "text": "盆满钵满", "hint": false, "point": 10 },
		{ "flag": "a067", "name": "花费金币", "text": "视小钱如粪土", "hint": false, "point": 1 },
		{ "flag": "a068", "name": "花费100金币", "text": "一张一百元金币", "hint": false, "point": 2 },
		{ "flag": "a069", "name": "花费1000金币", "text": "你都买了啥？", "hint": false, "point": 5 },
		{ "flag": "a070", "name": "花费1万金币", "text": "有这钱干点啥不好", "hint": false, "point": 10 },
		{ "flag": "a071", "name": "攻击力20", "text": "拿到剑了吗？", "hint": false, "point": 2 },
		{ "flag": "a072", "name": "攻击力50", "text": "一刀一个小朋友", "hint": false, "point": 4 },
		{ "flag": "a073", "name": "攻击力100", "text": "人形神圣剑", "hint": false, "point": 6 },
		{ "flag": "a074", "name": "攻击力200", "text": "独当一面", "hint": false, "point": 8 },
		{ "flag": "a075", "name": "攻击力400", "text": "还是打不动高级卫兵", "hint": false, "point": 10 },
		{ "flag": "a076", "name": "防御力20", "text": "这有一块盾", "hint": false, "point": 2 },
		{ "flag": "a077", "name": "防御力50", "text": "防杀真好玩", "hint": false, "point": 4 },
		{ "flag": "a078", "name": "防御力100", "text": "勇者该有的耐力", "hint": false, "point": 6 },
		{ "flag": "a079", "name": "防御力200", "text": "坚如磐石", "hint": false, "point": 8 },
		{ "flag": "a080", "name": "防御力400", "text": "一直以来的努力没有白费", "hint": false, "point": 10 },
		{ "flag": "a081", "name": "打开黄门", "text": "上帝给你关了一扇窗", "hint": false, "point": 2 },
		{ "flag": "a082", "name": "打开蓝门", "text": "不是让你去玩蓝色的角色", "hint": false, "point": 5 },
		{ "flag": "a083", "name": "打开红门", "text": "中国人不关中国门", "hint": false, "point": 8 },
		{ "flag": "a084", "name": "打开暗墙", "text": "俺就是摸了一下", "hint": false, "point": 1 },
		{ "flag": "a085", "name": "打开10次黄门", "text": "大黄门钥匙", "hint": false, "point": 3 },
		{ "flag": "a086", "name": "打开100次黄门", "text": "百门斩", "hint": false, "point": 6 },
		{ "flag": "a087", "name": "打开所有黄门", "text": "我也是黄海塔", "hint": false, "point": 10 },
		{ "flag": "a088", "name": "打开10次蓝门", "text": "物以稀为贵", "hint": false, "point": 5 },
		{ "flag": "a089", "name": "打开所有蓝门", "text": "蓝色的君王", "hint": false, "point": 10 },
		{ "flag": "a090", "name": "打开3次红门", "text": "神秘红色房间", "hint": false, "point": 5 },
		{ "flag": "a091", "name": "打开所有红门", "text": "开门红", "hint": false, "point": 10 },
		{ "flag": "a092", "name": "打开10次暗墙", "text": "豆腐渣工程", "hint": false, "point": 5 },
		{ "flag": "a093", "name": "打开所有暗墙", "text": "穿墙邪仙", "hint": false, "point": 10 },
		{ "flag": "a094", "name": "打开绿门", "text": "又是一个新成就……", "hint": false, "point": 3 },
		{ "flag": "a095", "name": "打开所有绿门", "text": "……或者是两个？", "hint": false, "point": 4 },
		{ "flag": "a096", "name": "打开机关门", "text": "谁拉的拉杆？", "hint": false, "point": 3 },
		{ "flag": "a097", "name": "打开10次机关门", "text": "反正我没碰", "hint": false, "point": 6 },
		{ "flag": "a098", "name": "打开铁门", "text": "掰弯栏杆", "hint": false, "point": 5 },
		{ "flag": "a099", "name": "打开所有铁门", "text": "监狱真是个好地方", "hint": false, "point": 5 },
		{ "flag": "a100", "name": "到达0层", "text": "……终于", "hint": false, "point": 10 },
		{ "flag": "a101", "name": "到达1层", "text": "Hello,tower", "hint": false, "point": 1 },
		{ "flag": "a102", "name": "到达2层", "text": "我还会回来的", "hint": false, "point": 1 },
		{ "flag": "a103", "name": "到达3层", "text": "有什么要发生了", "hint": false, "point": 1 },
		{ "flag": "a104", "name": "到达4层", "text": "最没用的祭坛", "hint": false, "point": 1 },
		{ "flag": "a105", "name": "到达5层", "text": "有暗墙！", "hint": false, "point": 1 },
		{ "flag": "a106", "name": "到达6层", "text": "6", "hint": false, "point": 2 },
		{ "flag": "a107", "name": "到达7层", "text": "一个随机的数字", "hint": false, "point": 2 },
		{ "flag": "a108", "name": "到达8层", "text": "能不能不打卫兵啊", "hint": false, "point": 2 },
		{ "flag": "a109", "name": "到达9层", "text": "我来了！", "hint": false, "point": 2 },
		{ "flag": "a110", "name": "到达10层", "text": "强敌出现！", "hint": false, "point": 2 },
		{ "flag": "a111", "name": "到达11层", "text": "新的层级", "hint": false, "point": 3 },
		{ "flag": "a112", "name": "到达12层", "text": "4次以内没有关系", "hint": false, "point": 3 },
		{ "flag": "a113", "name": "到达13层", "text": "神圣的光辉", "hint": false, "point": 3 },
		{ "flag": "a114", "name": "到达14层", "text": "以防你不知道，这里藏着什么", "hint": false, "point": 3 },
		{ "flag": "a115", "name": "到达15层", "text": "好大！", "hint": false, "point": 3 },
		{ "flag": "a116", "name": "到达16层", "text": "有没有一股氨水的味道？", "hint": false, "point": 4 },
		{ "flag": "a117", "name": "到达17层", "text": "强力的武器应当配备弱小的守卫", "hint": false, "point": 4 },
		{ "flag": "a118", "name": "到达18层", "text": "赶快上楼吧", "hint": false, "point": 4 },
		{ "flag": "a119", "name": "到达19层", "text": "救赎之道，就在其中", "hint": false, "point": 4 },
		{ "flag": "a120", "name": "到达20层", "text": "大蒜真好吃", "hint": false, "point": 4 },
		{ "flag": "a121", "name": "到达21层", "text": "新的……区域？", "hint": false, "point": 5 },
		{ "flag": "a122", "name": "到达22层", "text": "不存在的", "hint": false, "point": 5 },
		{ "flag": "a123", "name": "到达23层", "text": "一些成就", "hint": false, "point": 5 },
		{ "flag": "a124", "name": "到达24层", "text": "有人在等着你", "hint": false, "point": 5 },
		{ "flag": "a125", "name": "到达25层", "text": "中心点", "hint": false, "point": 5 },
		{ "flag": "a126", "name": "到达26层", "text": "我就是冲着这个来的", "hint": false, "point": 6 },
		{ "flag": "a127", "name": "到达27层", "text": "成功学大师", "hint": false, "point": 6 },
		{ "flag": "a128", "name": "到达28层", "text": "钥匙无铜", "hint": false, "point": 6 },
		{ "flag": "a129", "name": "到达29层", "text": "暗道都是哪来的", "hint": false, "point": 6 },
		{ "flag": "a130", "name": "到达30层", "text": "史莱姆全村的希望", "hint": false, "point": 6 },
		{ "flag": "a131", "name": "到达31层", "text": "阶级提升！", "hint": false, "point": 7 },
		{ "flag": "a132", "name": "到达32层", "text": "神圣庄严的古战场", "hint": false, "point": 7 },
		{ "flag": "a133", "name": "到达33层", "text": "心急吃不了热豆腐", "hint": false, "point": 7 },
		{ "flag": "a134", "name": "到达34层", "text": "真想要大黄门钥匙", "hint": false, "point": 7 },
		{ "flag": "a135", "name": "到达35层", "text": "龙之谷", "hint": false, "point": 7 },
		{ "flag": "a136", "name": "到达36层", "text": "十字路口", "hint": false, "point": 8 },
		{ "flag": "a137", "name": "到达37层", "text": "是谁怎么把东西放进去的？", "hint": false, "point": 8 },
		{ "flag": "a138", "name": "到达38层", "text": "快去拿盾", "hint": false, "point": 8 },
		{ "flag": "a139", "name": "到达39层", "text": "在3:45，藏有钟表谜题的层就会出现", "hint": false, "point": 8 },
		{ "flag": "a140", "name": "到达40层", "text": "实力强又谦虚", "hint": false, "point": 8 },
		{ "flag": "a141", "name": "到达41层", "text": "层14达到", "hint": false, "point": 9 },
		{ "flag": "a142", "name": "到达42层", "text": "命运之地", "hint": false, "point": 9 },
		{ "flag": "a143", "name": "到达43层", "text": "这里的陷阱很久没用了", "hint": false, "point": 9 },
		{ "flag": "a144", "name": "到达44层", "text": "我来了！！！", "hint": false, "point": 9 },
		{ "flag": "a145", "name": "到达45层", "text": "治疗很重要", "hint": false, "point": 9 },
		{ "flag": "a146", "name": "到达46层", "text": "直奔此处", "hint": false, "point": 10 },
		{ "flag": "a147", "name": "到达47层", "text": "在这里，对称飞很有用", "hint": false, "point": 10 },
		{ "flag": "a148", "name": "到达48层", "text": "门到底坏没坏啊", "hint": false, "point": 10 },
		{ "flag": "a149", "name": "到达49层", "text": "最终决战！其实也不是啦", "hint": false, "point": 10 },
		{ "flag": "a150", "name": "到达50层", "text": "塔顶", "hint": false, "point": 10 },
		{ "flag": "a151", "name": "来到1区商店", "text": "放心，不需要1区加点", "hint": false, "point": 2 },
		{ "flag": "a152", "name": "来到2区商店", "text": "它在这是有原因的", "hint": false, "point": 4 },
		{ "flag": "a153", "name": "来到4区商店", "text": "中间是不是少了一个？", "hint": false, "point": 6 },
		{ "flag": "a154", "name": "来到5区商店", "text": "闭嘴然后拿走我的钱", "hint": false, "point": 8 },
		{ "flag": "a155", "name": "购买攻击", "text": "那就对了", "hint": false, "point": 2 },
		{ "flag": "a156", "name": "购买防御", "text": "令人愉快", "hint": false, "point": 2 },
		{ "flag": "a157", "name": "购买生命", "text": "成功之选", "hint": false, "point": 2 },
		{ "flag": "a158", "name": "购买10次属性", "text": "塔里赚钱塔里花", "hint": false, "point": 4 },
		{ "flag": "a159", "name": "行走100步", "text": "有人在后面笑你", "hint": false, "point": 2 },
		{ "flag": "a160", "name": "行走1万步", "text": "读不到书", "hint": false, "point": 0 },
		{ "flag": "a161", "name": "击败绿色史莱姆", "text": "史莱姆低人一等吗？", "hint": false, "point": 1 },
		{ "flag": "a162", "name": "击败红色史莱姆", "text": "史莱姆低人一等吧。", "hint": false, "point": 2 },
		{ "flag": "a163", "name": "击败黑色史莱姆", "text": "黑芝麻球", "hint": false, "point": 4 },
		{ "flag": "a164", "name": "击败史莱姆王", "text": "皇家凝胶", "hint": false, "point": 8 },
		{ "flag": "a165", "name": "击败小蝙蝠", "text": "主食是水果", "hint": false, "point": 2 },
		{ "flag": "a166", "name": "击败大蝙蝠", "text": "魅魔同款翅膀", "hint": false, "point": 4 },
		{ "flag": "a167", "name": "击败红蝙蝠", "text": "这里也有蝙蝠", "hint": false, "point": 8 },
		{ "flag": "a168", "name": "击败吸血鬼", "text": "银色子弹", "hint": false, "point": 10 },
		{ "flag": "a169", "name": "击败骷髅人", "text": "需要牛奶吗？", "hint": false, "point": 2 },
		{ "flag": "a170", "name": "击败骷髅士兵", "text": "死了都要服役", "hint": false, "point": 4 },
		{ "flag": "a171", "name": "击败骷髅队长", "text": "王宫的通告", "hint": false, "point": 10 },
		{ "flag": "a172", "name": "击败鬼战士", "text": "鬼！", "hint": false, "point": 6 },
		{ "flag": "a173", "name": "击败兽人", "text": "为什么兽人会怕十字架？", "hint": false, "point": 2 },
		{ "flag": "a174", "name": "击败兽人武士", "text": "因为它们其实是丧尸", "hint": false, "point": 4 },
		{ "flag": "a175", "name": "击败石头人", "text": "加了多少次攻", "hint": false, "point": 6 },
		{ "flag": "a176", "name": "击败幽灵", "text": "我的朋友", "hint": false, "point": 5 },
		{ "flag": "a177", "name": "击败初级法师", "text": "拿法杖敲人", "hint": false, "point": 2 },
		{ "flag": "a178", "name": "击败高级法师", "text": "炎爆术", "hint": false, "point": 4 },
		{ "flag": "a179", "name": "击败初级巫师", "text": "学传送了吗", "hint": false, "point": 6 },
		{ "flag": "a180", "name": "击败高级巫师", "text": "风筝大师", "hint": false, "point": 8 },
		{ "flag": "a181", "name": "击败初级卫兵", "text": "小升初", "hint": false, "point": 2 },
		{ "flag": "a182", "name": "击败中级卫兵", "text": "中二病", "hint": false, "point": 5 },
		{ "flag": "a183", "name": "击败高级卫兵", "text": "你是用炸的，对吧？", "hint": false, "point": 8 },
		{ "flag": "a184", "name": "击败双手剑士", "text": "刀刃都砍卷", "hint": false, "point": 5 },
		{ "flag": "a185", "name": "击败战士", "text": "抢注人类职业名称", "hint": false, "point": 5 },
		{ "flag": "a186", "name": "击败骑士队长", "text": "实力差又爱吹牛", "hint": false, "point": 10 },
		{ "flag": "a187", "name": "击败骑士", "text": "根本骑不了马", "hint": false, "point": 5 },
		{ "flag": "a188", "name": "击败黑暗骑士", "text": "没有父母", "hint": false, "point": 8 },
		{ "flag": "a189", "name": "击败魔法警卫", "text": "它们都是双胞胎", "hint": false, "point": 8 },
		{ "flag": "a190", "name": "击败大章鱼", "text": "烤克苏鲁", "hint": false, "point": 10 },
		{ "flag": "a191", "name": "击败魔龙", "text": "它只是在那里睡觉……", "hint": false, "point": 10 },
		{ "flag": "a192", "name": "击败黑暗大法师", "text": "穞堵臸猭畍", "hint": false, "point": 10 },
		{ "flag": "a193", "name": "击败假魔王", "text": "不好，剧透了", "hint": false, "point": 5 },
		{ "flag": "a194", "name": "击败真魔王", "text": "结束了", "hint": false, "point": 0 },
		{ "flag": "a195", "name": "击败10个敌人", "text": "新手冒险者", "hint": false, "point": 2 },
		{ "flag": "a196", "name": "击败50个敌人", "text": "小有心得", "hint": false, "point": 4 },
		{ "flag": "a197", "name": "击败100个敌人", "text": "得心应手", "hint": false, "point": 6 },
		{ "flag": "a198", "name": "击败200个敌人", "text": "久经沙场", "hint": false, "point": 8 },
		{ "flag": "a199", "name": "击败400个敌人", "text": "寂静之塔", "hint": false, "point": 10 },
		{ "flag": "a200", "name": "战胜boss", "text": "阶段性胜利", "hint": false, "point": 5 },
		{ "flag": "a201", "name": "试图撬锁", "text": "锁孔在哪？", "hint": false, "point": 2 },
		{ "flag": "a202", "name": "撞击墙壁", "text": "咚！", "hint": false, "point": 3 },
		{ "flag": "a203", "name": "和商人互动", "text": "他们都长一个样", "hint": false, "point": 2 },
		{ "flag": "a204", "name": "尝试自杀", "text": "想重开请按F5", "hint": false, "point": 4 },
		{ "flag": "a205", "name": "踏入陷阱", "text": "欲望泥潭", "hint": false, "point": 6 },
		{ "flag": "a206", "name": "0伤击杀", "text": "不费吹灰之力", "hint": false, "point": 3 },
		{ "flag": "a207", "name": "和魔王对话", "text": "大boss总不会补刀", "hint": false, "point": 1 },
		{ "flag": "a208", "name": "两手空空", "text": "但你还有4块钱", "hint": false, "point": 1 },
		{ "flag": "a209", "name": "被送进监狱", "text": "梦结束的地方", "hint": false, "point": 1 },
		{ "flag": "a210", "name": "破墙不用镐", "text": "教练，我想学这个", "hint": false, "point": 1 },
		{ "flag": "a211", "name": "被史莱姆可怜", "text": "低史莱姆一等", "hint": false, "point": 2 },
		{ "flag": "a212", "name": "恩将仇报", "text": "你怎么能这样", "hint": false, "point": 4 },
		{ "flag": "a213", "name": "和小偷对话", "text": "被抓肯定跑", "hint": false, "point": 1 },
		{ "flag": "a214", "name": "又和小偷对话", "text": "谁叫我是勇者呢", "hint": false, "point": 2 },
		{ "flag": "a215", "name": "双和小偷对话", "text": "勇者也需要帮助", "hint": false, "point": 3 },
		{ "flag": "a216", "name": "叒和小偷对话", "text": "他什么时候上来的？", "hint": false, "point": 4 },
		{ "flag": "a217", "name": "叕和小偷对话", "text": "收下我最后的暗道吧", "hint": false, "point": 8 },
		{ "flag": "a218", "name": "救出小偷", "text": "龙场悟道", "hint": false, "point": 6 },
		{ "flag": "a219", "name": "小偷的真相", "text": "噢，真惊讶", "hint": false, "point": 10 },
		{ "flag": "a220", "name": "跳过小偷", "text": "发现了世界的BUG", "hint": false, "point": 8 },
		{ "flag": "a221", "name": "罠", "text": "陷阱卡发动", "hint": false, "point": 3 },
		{ "flag": "a222", "name": "吸血鬼现身", "text": "掀开棺材板", "hint": false, "point": 4 },
		{ "flag": "a223", "name": "遭遇骑士队长", "text": "骑士冲锋", "hint": false, "point": 5 },
		{ "flag": "a224", "name": "骑士团冲击", "text": "静候多时了", "hint": false, "point": 6 },
		{ "flag": "a225", "name": "本性流露", "text": "临阵脱逃", "hint": false, "point": 4 },
		{ "flag": "a226", "name": "骑士队长陨落", "text": "不要停下来啊", "hint": false, "point": 7 },
		{ "flag": "a227", "name": "魔王现身！", "text": "还带着守卫", "hint": false, "point": 8 },
		{ "flag": "a228", "name": "封印魔王！", "text": "他自己干的", "hint": false, "point": 5 },
		{ "flag": "a229", "name": "探索缝隙", "text": "居然什么都没有？", "hint": false, "point": 5 },
		{ "flag": "a230", "name": "探索密道", "text": "好窄", "hint": false, "point": 4 },
		{ "flag": "a231", "name": "全副武装", "text": "比空手强", "hint": false, "point": 3 },
		{ "flag": "a232", "name": "这没有楼传", "text": "不要回来", "hint": false, "point": 3 },
		{ "flag": "a233", "name": "记事本之殇", "text": "它在你兜里", "hint": false, "point": 3 },
		{ "flag": "a234", "name": "钥匙贩卖", "text": "千金不换", "hint": false, "point": 3 },
		{ "flag": "a235", "name": "钥匙回收", "text": "十倍差价", "hint": false, "point": 3 },
		{ "flag": "a236", "name": "进行试炼", "text": "超越过去的自己", "hint": false, "point": 4 },
		{ "flag": "a237", "name": "隐藏的魔法守卫", "text": "摸鱼最光荣", "hint": false, "point": 8 },
		{ "flag": "a238", "name": "背刺", "text": "在你身后", "hint": false, "point": 6 },
		{ "flag": "a239", "name": "兽众", "text": "标准的副本体验", "hint": false, "point": 3 },
		{ "flag": "a240", "name": "九打大章鱼", "text": "没有战败CG", "hint": false, "point": 5 },
		{ "flag": "a241", "name": "冲破3区", "text": "赢了涂色游戏", "hint": false, "point": 9 },
		{ "flag": "a242", "name": "封印红钥匙", "text": "功力只剩10成", "hint": false, "point": 5 },
		{ "flag": "a243", "name": "解开钟表谜题", "text": "解不开没有成就", "hint": false, "point": 3 },
		{ "flag": "a244", "name": "炸死高级卫兵", "text": "what can I say", "hint": false, "point": 8 },
		{ "flag": "a245", "name": "宝库敞开", "text": "冒险就是为了这一刻", "hint": false, "point": 8 },
		{ "flag": "a246", "name": "左右对称", "text": "寺隐云游僧", "hint": false, "point": 7 },
		{ "flag": "a247", "name": "会说话的人偶", "text": "请使用我", "hint": false, "point": 6 },
		{ "flag": "a248", "name": "千伤强敌", "text": "我打它？真的假的", "hint": false, "point": 6 },
		{ "flag": "a249", "name": "那有个入侵者", "text": "我走了", "hint": false, "point": 8 },
		{ "flag": "a250", "name": "按下按钮", "text": "噗叽", "hint": false, "point": 1 },
		{ "flag": "a251", "name": "按10次按钮", "text": "10连击", "hint": false, "point": 2 },
		{ "flag": "a252", "name": "按20次按钮", "text": "被陌生人按了", "hint": false, "point": 4 },
		{ "flag": "a253", "name": "按100次按钮", "text": "一回生百回熟", "hint": false, "point": 0 },
		{ "flag": "a254", "name": "按按钮5秒", "text": "你已经脏了", "hint": false, "point": 2 },
		{ "flag": "a255", "name": "按按钮30秒", "text": "游戏还开着呢", "hint": false, "point": 4 },
		{ "flag": "a256", "name": "开启自动清怪", "text": "不想清也会清掉", "hint": false, "point": 1 },
		{ "flag": "a257", "name": "开启自动拾取", "text": "已经，不需要卡血了", "hint": false, "point": 1 },
		{ "flag": "a258", "name": "关闭自动清怪", "text": "放慢脚步", "hint": false, "point": 1 },
		{ "flag": "a259", "name": "关闭自动拾取", "text": "后悔了吗？", "hint": false, "point": 1 },
		{ "flag": "a260", "name": "兑换成就奖励", "text": "自信的力量", "hint": false, "point": 1 },
		{ "flag": "a261", "name": "兑换道具", "text": "额外的快乐", "hint": false, "point": 3 },
		{ "flag": "a262", "name": "对话所有蓝象", "text": "旅程", "hint": false, "point": 10 },
		{ "flag": "a263", "name": "领取成就", "text": "免费的才是最好的", "hint": false, "point": 5 },
		{ "flag": "a264", "name": "使用远程商店", "text": "娇交快递为您服务", "hint": false, "point": 3 },
		{ "flag": "a265", "name": "试图赊账", "text": "但失败了", "hint": false, "point": 3 },
		{ "flag": "a266", "name": "钥匙包", "text": "只是有很多钥匙", "hint": false, "point": 6 },
		{ "flag": "a267", "name": "2025", "text": "完全平方数", "hint": false, "point": 5 },
		{ "flag": "a268", "name": "存储游戏", "text": "使用自动售货机", "hint": false, "point": 2 },
		{ "flag": "a269", "name": "读取游戏", "text": "上膛", "hint": false, "point": 2 },
		{ "flag": "a270", "name": "使用怪物手册", "text": "知识的宝库", "hint": false, "point": 1 },
		{ "flag": "a271", "name": "使用记事本", "text": "有的人很喜欢勋章", "hint": false, "point": 1 },
		{ "flag": "a272", "name": "使用楼层传送器", "text": "移动电梯", "hint": false, "point": 1 },
		{ "flag": "a273", "name": "使用圣水", "text": "香！", "hint": false, "point": 3 },
		{ "flag": "a274", "name": "使用破墙镐", "text": "黄金矿工", "hint": false, "point": 4 },
		{ "flag": "a275", "name": "使用炸弹", "text": "这就是艺术", "hint": false, "point": 4 },
		{ "flag": "a276", "name": "使用对称飞", "text": "飞一般的感觉", "hint": false, "point": 3 },
		{ "flag": "a277", "name": "使用上楼器", "text": "通天术", "hint": false, "point": 6 },
		{ "flag": "a278", "name": "使用下楼器", "text": "6充能", "hint": false, "point": 6 },
		{ "flag": "a279", "name": "使用冰冻徽章", "text": "黑曜石！", "hint": false, "point": 6 },
		{ "flag": "a280", "name": "使用大黄门钥匙", "text": "门徒", "hint": false, "point": 6 },
		{ "flag": "a281", "name": "使用地震卷轴", "text": "想摧毁一座塔得靠别的", "hint": false, "point": 9 },
		{ "flag": "a282", "name": "铜星", "text": "这是谁掉的", "hint": false, "point": 3 },
		{ "flag": "a283", "name": "银星", "text": "送给谁好呢", "hint": false, "point": 6 },
		{ "flag": "a284", "name": "金星", "text": "闪闪发光", "hint": false, "point": 9 },
		{ "flag": "a285", "name": "完成10个成就", "text": "只是开始", "hint": false, "point": 1 },
		{ "flag": "a286", "name": "完成50个成就", "text": "小有所成", "hint": false, "point": 3 },
		{ "flag": "a287", "name": "完成100个成就", "text": "还有多少", "hint": false, "point": 5 },
		{ "flag": "a288", "name": "完成200个成就", "text": "荣誉满屋", "hint": false, "point": 7 },
		{ "flag": "a289", "name": "完成300个成就", "text": "现在你满足了吗？", "hint": false, "point": 9 },
		{ "flag": "a290", "name": "到达2区", "text": "倍率提升！", "hint": false, "point": 2 },
		{ "flag": "a291", "name": "到达3区", "text": "神秘之地", "hint": false, "point": 3 },
		{ "flag": "a292", "name": "到达4区", "text": "怎么没有1区的成就", "hint": false, "point": 4 },
		{ "flag": "a293", "name": "到达5区", "text": "塔尖耸入云霄", "hint": false, "point": 5 },
		{ "flag": "a294", "name": "受到领域伤害", "text": "法爷就是爷", "hint": false, "point": 4 },
		{ "flag": "a295", "name": "受到阻击伤害", "text": "还要特意跑一步", "hint": false, "point": 5 },
		{ "flag": "a296", "name": "受到夹击伤害", "text": "真实伤害", "hint": false, "point": 6 },
		{ "flag": "a297", "name": "受到血网伤害", "text": "疼！", "hint": false, "point": 7 },
		{ "flag": "a298", "name": "游玩一小时", "text": "感谢游玩", "hint": false, "point": 0 },
		{ "flag": "a299", "name": "点击本成就", "text": "被你发现啦", "hint": false, "point": 5 },
		{ "flag": "a300", "name": "发现隐藏的门", "text": "此地无银三百两", "hint": false, "point": 3 },
		{ "flag": "a301", "name": "进入成就博物馆", "text": "人嘛，总要成就点什么", "hint": false, "point": 5 },
		{ "flag": "a302", "name": "确认历史成就", "text": "收集狂", "hint": false, "point": 6 },
		{ "flag": "a303", "name": "幸运7", "text": "真是好幸运呢", "hint": false, "point": 4 },
		{ "flag": "a304", "name": "空盒计", "text": "生而为盒，我很抱歉", "hint": false, "point": 7 },
		{ "flag": "a305", "name": "EYEZMAZE", "text": "重获新生", "hint": false, "point": 8 },
		{ "flag": "a306", "name": "大理石台阶", "text": "这也是艺术", "hint": false, "point": 2 },
		{ "flag": "a307", "name": "感谢游玩", "text": "请支持本塔", "hint": false, "point": 9 },
		{ "flag": "a308", "name": "1.03", "text": "塔利率", "hint": false, "point": 3 },
		{ "flag": "a309", "name": "好人有好报", "text": "这是你应得的", "hint": false, "point": 7 },
		{ "flag": "a310", "name": "比如这个", "text": "是啊是啊", "hint": false, "point": 2 },
		{ "flag": "a311", "name": "缓解寂寞", "text": "有偿的社交帮助", "hint": false, "point": 2 },
		{ "flag": "a312", "name": "统计数据", "text": "统计学不魅力时刻", "hint": false, "point": 2 },
		{ "flag": "a313", "name": "矛与盾", "text": "与", "hint": false, "point": 3 },
		{ "flag": "a314", "name": "找到了", "text": "在这儿呢", "hint": false, "point": 3 },
		{ "flag": "a315", "name": "不是这个", "text": "是另一个", "hint": false, "point": 3 },
		{ "flag": "a316", "name": "神秘档案馆", "text": "通关后再去有惊喜", "hint": false, "point": 4 },
		{ "flag": "a317", "name": "前人教训", "text": "他人还蛮好嘞", "hint": false, "point": 4 },
		{ "flag": "a318", "name": "自杀式袭击", "text": "板载！", "hint": false, "point": 4 },
		{ "flag": "a319", "name": "无话可说", "text": "\\u0020", "hint": false, "point": 5 },
		{ "flag": "a320", "name": "成功学", "text": "如同这段话一般有用", "hint": false, "point": 5 },
		{ "flag": "a321", "name": "原来这TM是惊喜啊", "text": "翻译翻译", "hint": false, "point": 5 },
		{ "flag": "a322", "name": "防杀的胜利", "text": "双手盾卫", "hint": false, "point": 6 },
		{ "flag": "a323", "name": "放慢脚步", "text": "喝杯咖啡休息下吧", "hint": false, "point": 6 },
		{ "flag": "a324", "name": "一个成就", "text": "获得成就", "hint": false, "point": 6 },
		{ "flag": "a325", "name": "49层？", "text": "就只有两颗宝石", "hint": false, "point": 7 },
		{ "flag": "a326", "name": "镐", "text": "拆", "hint": false, "point": 7 },
		{ "flag": "a327", "name": "谜题", "text": "大黄门钥匙？", "hint": false, "point": 7 },
		{ "flag": "a328", "name": "秘密", "text": "这是个秘密", "hint": false, "point": 8 },
		{ "flag": "a329", "name": "太痛苦了", "text": "人们说伤疤是勋章", "hint": false, "point": 8 },
		{ "flag": "a330", "name": "那我呢？", "text": "我到底是不是成就啊", "hint": false, "point": 8 },
		{ "flag": "a331", "name": "在44楼", "text": "对，没错", "hint": false, "point": 9 },
		{ "flag": "a332", "name": "左右对称", "text": "以我为中心", "hint": false, "point": 9 },
		{ "flag": "a333", "name": "伟大的勇士", "text": "现在你是了", "hint": false, "point": 9 },
		{ "flag": "a334", "name": "十字封印", "text": "不对是五字", "hint": false, "point": 5 },
		{ "flag": "a335", "name": "天震卷轴", "text": "看，有飞机", "hint": false, "point": 10 },
		{ "flag": "a336", "name": "大黄门钥匙", "text": "你来真的啊？", "hint": false, "point": 7 },
		{ "flag": "a337", "name": "破门而入", "text": "夺门而出", "hint": false, "point": 8 },
		{ "flag": "a338", "name": "转身", "text": "昂贵的转身", "hint": false, "point": 5 },
		{ "flag": "a339", "name": "史莱姆毁灭者", "text": "How dare you", "hint": false, "point": 6 },
		{ "flag": "a340", "name": "自投罗网", "text": "周围全是空气墙", "hint": false, "point": 9 },
		{ "flag": "a341", "name": "层下有层", "text": "其实也没有啦", "hint": false, "point": 8 },
		{ "flag": "a342", "name": "开盖即食", "text": "原味", "hint": false, "point": 5 },
		{ "flag": "a343", "name": "禁忌知识", "text": "那个存在", "hint": false, "point": 7 },
		{ "flag": "a344", "name": "你打算去哪？", "text": "请走正门", "hint": false, "point": 2 },
		{ "flag": "a345", "name": "在2楼右上角", "text": "使用笔记本就会……？", "hint": false, "point": 3 },
		{ "flag": "a371", "name": "击败20个史莱姆族", "text": "史莱姆凝胶", "hint": false, "point": 2 },
		{ "flag": "a372", "name": "击败40个史莱姆族", "text": "史莱姆软皮", "hint": false, "point": 4 },
		{ "flag": "a373", "name": "击败80个史莱姆族", "text": "史莱姆核心", "hint": false, "point": 6 },
		{ "flag": "a374", "name": "击败20个蝙蝠族", "text": "蝙蝠翅膀", "hint": false, "point": 3 },
		{ "flag": "a375", "name": "击败40个蝙蝠族", "text": "蝙蝠眼球", "hint": false, "point": 4 },
		{ "flag": "a376", "name": "击败80个蝙蝠族", "text": "血之精华", "hint": false, "point": 5 },
		{ "flag": "a377", "name": "击败20个骷髅族", "text": "指骨", "hint": false, "point": 2 },
		{ "flag": "a378", "name": "击败40个骷髅族", "text": "腿骨", "hint": false, "point": 5 },
		{ "flag": "a379", "name": "击败60个骷髅族", "text": "头骨", "hint": false, "point": 8 },
		{ "flag": "a380", "name": "击败20个法师族", "text": "以太粉尘", "hint": false, "point": 3 },
		{ "flag": "a381", "name": "击败40个法师族", "text": "法力之泉", "hint": false, "point": 6 },
		{ "flag": "a382", "name": "击败60个法师族", "text": "虚空精华", "hint": false, "point": 9 },
		{ "flag": "a383", "name": "击败10个骑士族", "text": "破碎铁铠", "hint": false, "point": 5 },
		{ "flag": "a384", "name": "击败20个骑士族", "text": "精钢重甲+3", "hint": false, "point": 7 },
		{ "flag": "a385", "name": "击败50个骑士族", "text": "秘银圣甲+12", "hint": false, "point": 9 },
		{ "flag": "a351", "name": "受到1000战斗伤害", "text": "小伤而已", "hint": false, "point": 3 },
		{ "flag": "a352", "name": "受到5000战斗伤害", "text": "流血不止", "hint": false, "point": 4 },
		{ "flag": "a353", "name": "受到1万战斗伤害", "text": "百折不挠", "hint": false, "point": 5 },
		{ "flag": "a354", "name": "受到2万战斗伤害", "text": "还活着", "hint": false, "point": 0 },
		{ "flag": "a355", "name": "拥有1000生命", "text": "曾经的自己", "hint": false, "point": 3 },
		{ "flag": "a356", "name": "拥有5000生命", "text": "吃饱喝足", "hint": false, "point": 5 },
		{ "flag": "a357", "name": "拥有1万生命", "text": "血魔法师", "hint": false, "point": 7 },
		{ "flag": "a358", "name": "拥有3万生命", "text": "战前准备", "hint": false, "point": 9 },
		{ "flag": "a359", "name": "获得1区宝石", "text": "很好……", "hint": false, "point": 2 },
		{ "flag": "a360", "name": "获得2区宝石", "text": "力量……", "hint": false, "point": 3 },

		{ "flag": "a361", "name": "获得4区宝石", "text": "强大……", "hint": false, "point": 6 },
		{ "flag": "a362", "name": "获得5区宝石", "text": "终于……", "hint": false, "point": 7 },
		{ "flag": "a363", "name": "获得10枚宝石", "text": "来吧……", "hint": false, "point": 2 },
		{ "flag": "a364", "name": "获得20枚宝石", "text": "继续……", "hint": false, "point": 3 },
		{ "flag": "a365", "name": "获得30枚宝石", "text": "宝石的力量……", "hint": false, "point": 4 },
		{ "flag": "a366", "name": "获得40枚宝石", "text": "更多……", "hint": false, "point": 5 },
		{ "flag": "a367", "name": "获得50枚宝石", "text": "渴求吧……", "hint": false, "point": 6 },
		{ "flag": "a368", "name": "获得60枚宝石", "text": "贪婪吧……", "hint": false, "point": 7 },
		{ "flag": "a369", "name": "获得70枚宝石", "text": "欲望的力量……", "hint": false, "point": 8 },
		{ "flag": "a370", "name": "获得80枚宝石", "text": "无法满足的欲望", "hint": false, "point": 9 },
		{ "flag": "a386", "name": "秘密关卡", "text": "奶牛色", "hint": false, "point": 7 },
		{ "flag": "a388", "name": "坚实地面", "text": "不是给你准备的", "hint": false, "point": 2 },
		{ "flag": "a389", "name": "这只是草", "text": "尖尖的草", "hint": false, "point": 4 },
		{ "flag": "a390", "name": "红色石墩", "text": "为什么摆在这", "hint": false, "point": 5 },
		{ "flag": "a391", "name": "原路返回", "text": "Back Where You Started", "hint": false, "point": 8 },
		{ "flag": "a392", "name": "不绿的水管", "text": "里世界的入口", "hint": false, "point": 10 },
		{ "flag": "a393", "name": "游玩中", "text": "请勿打扰", "hint": false, "point": 3 },
		{ "flag": "a394", "name": "别人家的门", "text": "还是魔塔好", "hint": false, "point": 6 },
		{ "flag": "a387", "name": "芝麻开门", "text": "不用钥匙", "hint": false, "point": 9 },
		{ "flag": "a395", "name": "只有这一关", "text": "玩完就没了", "hint": false, "point": 10 },
		{ "flag": "a346", "name": "清空整层门", "text": "开门大吉", "hint": false, "point": 3 },
		{ "flag": "a347", "name": "清空整层敌人", "text": "安全区", "hint": false, "point": 3 },
		{ "flag": "a348", "name": "清空整层道具", "text": "没有利用价值了", "hint": false, "point": 6 },
		{ "flag": "a349", "name": "清空整层", "text": "任务完成！", "hint": false, "point": 9 },
		{ "flag": "a350", "name": "清空10层", "text": "擦除", "hint": false, "point": 2 },
		{ "flag": "a396", "name": "挠胳肢窝", "text": "好痒啊", "hint": false, "point": 3 },
		{ "flag": "a397", "name": "烫烫烫！", "text": "锟斤拷", "hint": false, "point": 4 },
		{ "flag": "a398", "name": "一脚踏空", "text": "眼冒金星", "hint": false, "point": 5 },
		{ "flag": "a399", "name": "隐藏讯息", "text": "可你只能看到墙壁", "hint": false, "point": 5 },
		{ "flag": "a400", "name": "通关游戏", "text": "结束……了？", "hint": false, "point": 0 },

		{ "flag": "a401", "name": "死亡", "text": "死神来了", "hint": false, "point": 10 },
		{ "flag": "a402", "name": "死里逃生", "text": "在魔法警卫面前跳舞", "hint": false, "point": 10 },
		{ "flag": "a403", "name": "比较成功", "text": "追随原初者的脚步", "hint": false, "point": 10 },
		{ "flag": "a404", "name": "not found", "text": "未定义", "hint": false, "point": 10 },
		{ "flag": "a405", "name": "穿越墙壁", "text": "这塔有这个功能？", "hint": false, "point": 0 },
		{ "flag": "a406", "name": "3:45", "text": "我写着玩的", "hint": false, "point": 0 },
		{ "flag": "a407", "name": "杀死入侵者", "text": "真死啦？", "hint": false, "point": 10 },
		{ "flag": "a408", "name": "十字围杀", "text": "没气了", "hint": false, "point": 10 },
		{ "flag": "a409", "name": "不该毁坏的东西", "text": "Oh,no", "hint": false, "point": 10 },
		{ "flag": "a410", "name": "真正的强大", "text": "完成所有非隐藏成就", "hint": false, "point": 10 },
		{ "flag": "a411", "name": "不成功人士", "text": "不要放弃治疗", "hint": false, "point": 10 },
		{ "flag": "a412", "name": "神鹰羽毛扫", "text": "直接攻击", "hint": false, "point": 10 },
		{ "flag": "a413", "name": "棺椁的封印", "text": "百年孤独", "hint": false, "point": 0 },
		{ "flag": "a414", "name": "飞跃40层", "text": "他太强大了", "hint": false, "point": 10 },
		{ "flag": "a415", "name": "神偷", "text": "神圣的盗窃犯", "hint": false, "point": 10 },
		{ "flag": "a416", "name": "我全都要", "text": "要及时享乐啊", "hint": false, "point": 10 },
		{ "flag": "a417", "name": "冰霜之地", "text": "冷", "hint": false, "point": 0 },
		{ "flag": "a418", "name": "不可撼动之物", "text": "黑曜石", "hint": false, "point": 0 },
		{ "flag": "a419", "name": "双手盾卫", "text": "你做到了", "hint": false, "point": 0 },







		// 可以继续往后新增其他的。
	];
	//快速获取某成就是否达成的方法，接收成就flag、索引数值和数组，数组的场合只有全部达成返回true
	this.AchievementsFlags = function (id, isLocalStorage) {
		if (!Array.isArray(id)) id = [id];
		let bool = true;
		id.forEach(function (e, i, a) {
			let aa = e;
			if (typeof e === 'number' && Number.isInteger(e)) { //当id是索引值时将其转化为flag名
				aa = core.plugin.achievements[e].flag;
			}
			if (isLocalStorage) { if (!(core.getLocalStorage("achievements:" + core.firstData.name, false)[aa] || false)) bool = false; } //读取LocalStorage的成就列表
			else { if (!(core.getFlag("achievements", false)[aa] || false)) bool = false; }
		})
		return bool;
	}
	//超好用的洗牌
	this.shuffleArray = function (array) {
		for (let i = array.length - 1; i > 0; i--) {
			const j = Math.floor(core.rand() * (i + 1));
			[array[i], array[j]] = [array[j], array[i]];
		}
		return array;
	}
	this.randomreward = function () {
		//随机奖励清单，可以通过reward数组添加奖励的内容，time代表该奖励的重复次数
		//会根据point自动匹配拥有对应point的成就
		let rewardslist = [ //在全塔资源总量的基础上去除了一些特定资源
			{ "type": "上楼器", "time": 1, "number": 1, "point": [4, 5, 6, 7], "get": false },
			{ "type": "下楼器", "time": 1, "number": 1, "point": [5, 6, 7, 8], "get": false },
			{ "type": "破墙镐", "time": 1, "number": 1, "point": [4, 5], "get": false },
			{ "type": "瞬移", "time": 3, "number": 1, "point": [3, 4, 6, 7], "get": false },
			{ "type": "炸弹", "time": 1, "number": 1, "point": [2, 8], "get": false },
			{ "type": "圣水", "time": 1, "number": 1, "point": [7], "get": false },
			{ "type": "大黄门钥匙", "time": 1, "number": 1, "point": [1, 3, 5], "get": false },
			{ "type": "大黄门钥匙", "time": 1, "number": 1, "point": [3, 5, 7], "get": false },
			{ "type": "大黄门钥匙", "time": 1, "number": 1, "point": [5, 7, 9], "get": false },
			{ "type": "地震卷轴", "time": 1, "number": 1, "point": [10], "get": false },
			{ "type": "绿钥匙", "time": 1, "number": 1, "point": [1, 4, 7], "get": false },
			{ "type": "绿宝石", "time": 1, "number": 1, "point": [1], "get": false },
			{ "type": "黄宝石", "time": 1, "number": 1, "point": [2], "get": false },
			{ "type": "黄血瓶", "time": 1, "number": 1, "point": [9], "get": false },
			{ "type": "绿血瓶", "time": 1, "number": 1, "point": [5], "get": false },
			//上方为特殊资源
			{ "type": "铁剑", "time": 1, "number": 1, "point": [1], "get": false },
			{ "type": "铁盾", "time": 1, "number": 1, "point": [1, 2, 3], "get": false },
			{ "type": "攻击力", "time": 10, "number": 1, "point": [1, 2, 3], "get": false },
			{ "type": "防御力", "time": 10, "number": 1, "point": [1, 2, 3], "get": false },
			{ "type": "黄钥匙", "time": 10, "number": 1, "point": [1, 2, 3], "get": false }, //总量55
			{ "type": "蓝钥匙", "time": 13, "number": 1, "point": [1, 2, 3, 4, 5, 6, 7, 8], "get": false },
			{ "type": "红钥匙", "time": 0, "number": 1, "point": [5, 8], "get": false }, //58
			{ "type": "生命值", "time": 18, "number": 100, "point": [1, 2, 3], "get": false }, //22红，12蓝，总计3500+监狱600血
			//上方为1区资源
			{ "type": "银剑", "time": 1, "number": 1, "point": [3, 4, 5], "get": false },
			{ "type": "银盾", "time": 1, "number": 1, "point": [3, 4, 5], "get": false },
			{ "type": "攻击力", "time": 10, "number": 2, "point": [3, 4, 5], "get": false },
			{ "type": "防御力", "time": 10, "number": 2, "point": [3, 4, 5], "get": false },
			{ "type": "黄钥匙", "time": 10, "number": 1, "point": [1, 2, 3, 4, 5], "get": false }, //总量44
			{ "type": "蓝钥匙", "time": 0, "number": 1, "point": [1, 2, 3, 4, 5, 6, 7, 8], "get": false }, //总量6
			{ "type": "红钥匙", "time": 0, "number": 1, "point": [4, 7], "get": false }, //47
			{ "type": "生命值", "time": 12, "number": 200, "point": [3, 4, 5], "get": false }, //22红，9蓝，总计4000
			//上方为2区资源
			{ "type": "攻击力", "time": 10, "number": 3, "point": [3, 4, 5, 6, 7], "get": false },
			{ "type": "防御力", "time": 10, "number": 3, "point": [3, 4, 5, 6, 7], "get": false },
			{ "type": "攻击力", "time": 5, "number": 10, "point": [10], "get": false },
			{ "type": "防御力", "time": 5, "number": 10, "point": [10], "get": false },
			//上方为额外添加的资源
			{ "type": "骑士剑", "time": 1, "number": 1, "point": [5, 6, 7], "get": false },
			{ "type": "骑士盾", "time": 1, "number": 1, "point": [5, 6, 7], "get": false },
			{ "type": "攻击力", "time": 13, "number": 4, "point": [5, 6, 7], "get": false },
			{ "type": "防御力", "time": 12, "number": 4, "point": [5, 6, 7], "get": false }, //游戏中12攻13防
			{ "type": "黄钥匙", "time": 10, "number": 1, "point": [3, 4, 5, 6, 7], "get": false },
			{ "type": "蓝钥匙", "time": 0, "number": 1, "point": [1, 2, 3, 4, 5, 6, 7, 8], "get": false },
			{ "type": "红钥匙", "time": 0, "number": 1, "point": [3, 6], "get": false }, //36
			{ "type": "生命值", "time": 12, "number": 300, "point": [5, 6, 7], "get": false }, //10红+37仓库10红，11蓝+37仓库2蓝，魔龙3蓝，总计10800+6000
			//上方为4区资源
			{ "type": "圣剑", "time": 1, "number": 1, "point": [7], "get": false },
			{ "type": "圣盾", "time": 1, "number": 1, "point": [8], "get": false },
			{ "type": "攻击力", "time": 10, "number": 5, "point": [7, 8, 9], "get": false },
			{ "type": "防御力", "time": 10, "number": 5, "point": [7, 8, 9], "get": false },
			{ "type": "黄钥匙", "time": 10, "number": 1, "point": [5, 6, 7, 8, 9], "get": false },
			{ "type": "蓝钥匙", "time": 0, "number": 1, "point": [1, 2, 3, 4, 5, 6, 7, 8], "get": false },
			{ "type": "红钥匙", "time": 1, "number": 1, "point": [3, 6, 9], "get": false }, //9
			{ "type": "生命值", "time": 21, "number": 400, "point": [7, 8, 9], "get": false }, //16红13蓝
			//上方为5区资源
		];
		let rewards = [];
		//push所有奖励并将剩余空位用空对象填满
		rewardslist.forEach(function (reward, index, array) {
			for (let a = 0; a < reward.time; a++) {
				const copy = JSON.parse(JSON.stringify(reward)); // 创建深拷贝
				rewards.push(copy);
			}
		});
		while (this.achievements.length > rewards.length) rewards.push({ "type": false });

		//调用洗牌
		rewards = this.shuffleArray(rewards);
		//将洗牌后的奖励按照point重新排序，使得每个奖励的索引值对应的成就和该奖励的point范围一致
		//将洗牌后的rewards按条件重新分配到新数组以匹配achievements的point
		let newRewards = new Array(this.achievements.length).fill(null).map(() => ({ "type": false }));
		let used = new Array(this.achievements.length).fill(false); //这附近调整隐藏范围
		//复制成就数组并将其打乱以确保随机性
		let randomachieve = this.achievements.map(function (a) { return a; });
		randomachieve = randomachieve.slice(0, 400);
		randomachieve = this.shuffleArray(randomachieve);
		rewards.forEach((a, originalIndex) => {
			if (a.type !== false) {
				let foundIndex = -1;

				// 优先查找原始索引之后的元素
				for (let i = originalIndex; i < randomachieve.length; i++) {
					if (!used[i] && a.point.includes(randomachieve[i].point)) {
						foundIndex = i;
						break;
					}
				}

				// 若未找到则从头开始查找
				if (foundIndex === -1) {
					for (let i = 0; i <= originalIndex; i++) {
						if (!used[i] && a.point.includes(randomachieve[i].point)) {
							foundIndex = i;
							break;
						}
					}
				}


				if (foundIndex === -1) {
					// 强制匹配模式（当理论存在但分配冲突时）
					let earliestIndex = Infinity;

					// 寻找最早可替换的已分配奖励
					for (let i = 0; i < newRewards.length; i++) {
						if (newRewards[i].type !== false &&
							a.point.includes(randomachieve[i].point)) {
							if (i < earliestIndex) {
								earliestIndex = i;
							}
						}
					}

					if (earliestIndex !== Infinity) {
						// 取出被替换元素并重新分配
						const replacedReward = newRewards[earliestIndex];
						newRewards[earliestIndex] = a;

						// 递归重新分配被替换元素（偏移原始索引）
						const recursionIndex = (earliestIndex + 1) % randomachieve.length;
						for (let i = recursionIndex; i < randomachieve.length; i++) {
							if (!used[i] && replacedReward.point.includes(randomachieve[i].point)) {
								newRewards[i] = replacedReward;
								used[i] = true;
								break;
							}
						}
						foundIndex = earliestIndex;
					}
				}

				// 找到则分配位置
				if (foundIndex !== -1) {
					newRewards[foundIndex] = a;
					used[foundIndex] = true;
				}
			}
		});
		randomachieve.forEach(function (a, index, array) { newRewards[index]["flag"] = a.flag });
		const indexMap = new Map(this.achievements.map((item, index) => [item.flag, index]));
		// 根据 b 中的顺序对 a 进行排序
		newRewards = newRewards.sort((objA, objB) => {
			return indexMap.get(objA.flag) - indexMap.get(objB.flag);
		});
		core.setFlag('随机奖励表', newRewards);
		return newRewards;
	}
	//发放奖励 ,按照索引和flag检测指定的随机奖励，分配并开启对应开关。请确保奖励分配完毕
	this.givereward = function (achieveFlag, re) { // 参数直接使用flag,为re输入true可以使函数不分配奖励而是返回奖励对象
		let rewardTable = core.getFlag('随机奖励表');
		//隐藏成就排除
		if (core.plugin.achievements.findIndex(item => item.flag === achieveFlag) < core.plugin.hideachieve) {
			// 通过flag查找奖励项
			let targetReward = rewardTable.find(item =>
				item.flag === achieveFlag);
			if (targetReward.type != false && targetReward.get === false) { //成功发放奖励会执行下列代码，请注意调整
				if (targetReward.type === '攻击力') core.addStatus('atk', targetReward.number);
				else if (targetReward.type === '防御力') core.addStatus('def', targetReward.number);
				else if (targetReward.type === '生命值') core.addStatus('hp', targetReward.number);
				else if (targetReward.type === '金币') core.addStatus('money', targetReward.number);
				else {
					core.getItem(Object.entries(core.items.items).find(item => item[1].name === targetReward.type)[1].id, targetReward.number);
					core.addFlag('达成成就', "a261:");
				}
				core.updateStatusBar();
				targetReward.get = true;
				core.setFlag('随机奖励表', rewardTable);
				core.addFlag('达成成就', "a260:");
			}
		}
	}
	//一次性发放所有未发放的奖励
	this.giveallreward = function () {
		this.achievements.forEach(function (achieve, index, array) {
			if (core.plugin.AchievementsFlags(achieve.flag)) core.plugin.givereward(achieve.flag)
		});
	}
	// 达成成就；
	this.achieve = function (flag) {
		// 获得已达成的成就
		let geta = false;
		var achievedF = core.getFlag("achievements", { a404: true });
		var achievedS = core.getLocalStorage("achievements:" + core.firstData.name, { a404: true });
		var point = core.getFlag("achievePoint", 0);
		var pointh = core.getFlag("achievePointhistory", 0);
		// 该成就是否已获得；如果跟存档则改成F，跟游戏则改成S
		if (achievedF[flag]) return;
		// 尝试达成成就；找到对应的成就项
		this.achievements.forEach(function (one, index) {
			if (one.flag == flag) {
				// 执行达成成就的操作；也可以自行在上面加上达成成就后的事件
				geta = true;
				let textr = '';
				if (core.getFlag('模式') === "随机模式" && core.getFlag('随机模式自动获取')) { //随机模式弹窗的文本生成
					let b = core.getFlag('随机奖励表').findIndex(item => item.flag === flag);
					if (b >= 0) {
						let c = core.getFlag('随机奖励表')[b];
						if (c.type) textr = c.type + '+' + c.number;
					}
				}
				core.addAchievementPopup(one.name, one.text, one.point, textr);
				point += one.point || 0;
				pointh += one.point || 0;
				if (core.getFlag('模式') === "加点模式") {
					let a = '获得了' + one.point + '成就点！总计有' + point + '成就点。';
					core.drawTip(a);
				}
				core.playSound('AchSound.mp3');
				achievedF[flag] = true;
				achievedS[flag] = true;
				//当随机模式自动获取开启时将奖励发给玩家
				if (core.getFlag('随机模式自动获取', false)) core.plugin.givereward(flag);
				// 如果需要将达成成就本身作为一个行为存储进录像则请取消下方的注释
				// 不推荐，没必要
				// if(!core.isReplaying())core.status.route.push("achievement:"+flag);
			}
		});
		// 存入flag和LocalStorage中
		core.setFlag("achievements", achievedF);
		core.setLocalStorage("achievements:" + core.firstData.name, achievedS);
		core.setFlag("achievePointhistory", pointh);
		core.setFlag("achievePoint", point);

		//成就后检测成就，放在这里避免数据冲突
		if (geta) {
			let b = Object.keys(achievedF).length;
			if (b > 10 && !core.plugin.AchievementsFlags("a285")) core.plugin.achieve("a285");
			if (b > 50 && !core.plugin.AchievementsFlags("a286")) core.plugin.achieve("a286");
			if (b > 100 && !core.plugin.AchievementsFlags("a287")) core.plugin.achieve("a287");
			if (b > 200 && !core.plugin.AchievementsFlags("a288")) core.plugin.achieve("a288");
			if (b > 300 && !core.plugin.AchievementsFlags("a289")) core.plugin.achieve("a289");
			let a = ["a213", "a214", "a215", "a216", "a218", "a217", "a219"];
			if (a.includes(flag) && !core.plugin.AchievementsFlags('a220')) {
				if (flag !== "a213" && !core.getFlag('二楼没跳小偷')) core.plugin.achieve("a220");
				a.forEach(function (achieve, index, array) {
					if ((index > array.findIndex(item => item === flag)) && core.plugin.AchievementsFlags(achieve)) core.plugin.achieve("a220");
				})
			}
			if (core.getFlag('nowWeapon') && core.getFlag('nowShield') && core.plugin.AchievementsFlags('a209')) core.plugin.achieve("a231");
			b = [];
			for (a = 10; a <= 37; a++) b.push(a);
			if (core.plugin.AchievementsFlags(b)) core.plugin.achieve("a040");
			if (core.plugin.AchievementsFlags([40, 42, 44, 46, 48])) core.plugin.achieve("a051");
			if (core.plugin.AchievementsFlags([41, 43, 45, 47, 49])) core.plugin.achieve("a052");
			if (core.plugin.AchievementsFlags([308, 309, 310, 315, 316, 317, 318, 319, 321, 322, 323, 324, 326, 328, 330, 331, 333])) core.plugin.achieve("a062");
			if (core.plugin.AchievementsFlags([307, 311, 312, 313, 314, 320, 325, 327, 329, 332, 233, 234])) core.plugin.achieve("a061");
			core.plugin.ac1();
		}
	}
	this.ac1 = function () {
		if (core.status.hero.hp === 2025) core.plugin.achieve("a267");
		if (core.status.hero.hp >= 5000) core.plugin.achieve("a356");
		if (core.status.hero.hp >= 10000) core.plugin.achieve("a357");
		if (core.status.hero.hp >= 30000) core.plugin.achieve("a358");
		//攻防成就
		if (core.plugin.AchievementsFlags('a209')) {
			if (core.status.hero.hp >= 1000) core.plugin.achieve("a355");
			if (core.status.hero.atk >= 20) core.plugin.achieve("a071");
			if (core.status.hero.atk >= 50) core.plugin.achieve("a072");
			if (core.status.hero.atk >= 100) core.plugin.achieve("a073");
			if (core.status.hero.atk >= 200) core.plugin.achieve("a074");
			if (core.status.hero.atk >= 400) core.plugin.achieve("a075");
			if (core.status.hero.def >= 20) core.plugin.achieve("a076");
			if (core.status.hero.def >= 50) core.plugin.achieve("a077");
			if (core.status.hero.def >= 100) core.plugin.achieve("a078");
			if (core.status.hero.def >= 200) core.plugin.achieve("a079");
			if (core.status.hero.def >= 400) core.plugin.achieve("a080");
			if (core.status.hero.def >= 680) core.plugin.achieve("a419");
		}
		//消费成就
		if (core.status.hero.statistics.money > core.status.hero.money) core.plugin.achieve("a067");
		if (core.status.hero.statistics.money >= core.status.hero.money + 100) core.plugin.achieve("a068");
		if (core.status.hero.statistics.money >= core.status.hero.money + 1000) core.plugin.achieve("a069");
		if (core.status.hero.statistics.money >= core.status.hero.money + 10000) core.plugin.achieve("a070");



		let list = core.getFlag('达成成就', '');
		if (list != '') {
			list = list.split(":");
			list.forEach(function (e, i, a) {
				core.plugin.achieve(e);
			})
			core.setFlag('达成成就', '');
		}
		if (core.itemCount('yellowKey') + core.itemCount('blueKey') + core.itemCount('redKey') + core.itemCount('greenKey') > 28) core.plugin.achieve("a266");
		let b = true;
		let a = ['book', 'wand', 'fly', 'cross', 'superPotion', 'pickaxe', 'bomb', 'centerFly', 'upFly', 'downFly', 'knife', 'snow', 'bigKey', 'earthquake', 'coin']
		for (let c = 0; c < a.length; c++) { if (!core.hasItem(a[c])) b = false; }
		if (b) core.plugin.achieve('a416');
	}
	this.ac2 = function () {
		let clearmap = core.getFlag("清图列表", []);
		let l = ["MT1", "MT2", "MT3", "MT4", "MT5", "MT6", "MT7", "MT8", "MT9", "MT10", "MT11", "MT12", "MT14", "MT15", "MT16", "MT17", "MT18", "MT19", "MT20", "MT25", "MT31", "MT32", "MT33", "MT34", "MT36", "MT37", "MT38", "MT39", "MT40", "MT41", "MT42", "MT43", "MT44", "MT45", "MT46", "MT47", "MT48", "MT49"];
		if (l.includes(core.status.floorId) && !clearmap.includes(core.status.floorId)) {
			let c = core.plugin.clearmapachieve();
			if (c) {
				core.plugin.achieve('a349');
				clearmap.push(core.status.floorId);
				core.setFlag("清图列表", clearmap);
				if (clearmap.length >= 10) core.plugin.achieve('a350');
			}
		}
	}
	this.clearmapachieve = function (mapid) { //检测一个图是否清空
		let m;
		if (!mapid) m = core.status.floorId;
		else m = mapid;
		let a = core.searchBlockWithFilter(function (block) { return block.event.id.endsWith('Door'); }, m);
		let b = core.searchBlockWithFilter(function (block) { return block.event.cls === ('items'); }, m);
		let c = core.searchBlockWithFilter(function (block) { return block.event.cls === ('enemys'); }, m);
		if (!a.length) core.plugin.achieve('a346');
		if (!c.length) core.plugin.achieve('a347');
		if (!b.length) core.plugin.achieve('a348');
		return a.length + b.length + c.length === 0;
	}
	// 获得所有成就说明；你也可以修改成自己的实现
	// 简单一点的可以使用insertAction+剧情文本；稍微复杂一点的可以使用图片化文本等；更复杂的可以自绘UI。
	this.getAchievements = function () {
		core.insertCommonEvent('记事本');
	}
},
    "弹出显示": function () {
	/*===== 成就弹窗系统 =====*/
	// 样式参数配置区
	const fontD = '10px Verdana'; // 描述文字字体
	const titleFontD = 'bold 14px Verdana'; // 标题字体（加粗）
	const colorD = 'yellow'; // 主要文字颜色
	const colorN = 'white'; // 次要文字颜色
	const borderColorD = 'rgba(200, 200, 200, 0.8)'; // 边框起始颜色
	const boldColorD = null; // 文字描边颜色
	const boldColorN = 'black'; // 次要描边颜色
	const popupWidth = 300; // 弹窗宽度（像素）
	const popupHeight = 25; // 弹窗高度（像素）
	const popupSpacing = 3; // 弹窗垂直间距（像素）
	const animationDuration = 30; // 入场动画时长（帧数）

	let popuplist = []; // 跟踪所有弹窗的清单（带索引位置）
	this.cleanPopup = function () { popuplist = []; }

	/*===== 弹窗管理逻辑 =====*/
	/**
	 * 添加新成就弹窗（核心API）
	 * @param {string} title - 成就标题
	 * @param {string} description - 成就描述
	 * @example
	 * core.addAchievementPopup("探索者", "发现隐藏房间",5)
	 */
	this.addAchievementPopup = function (title, description, point, textr) {
		// 清理超时弹窗（确保当前位置可复用）
		for (let i = 0; i < popuplist.length; i++) {
			const popup = popuplist[i];
			if (popup && popup.shouldRemove()) {
				popuplist[i] = undefined;
			}
		}

		// 统计当前有效弹窗数量
		const activeCount = popuplist.reduce((count, p) => p ? count + 1 : count, 0);

		// 确定目标插入位置
		let targetIndex = -1;
		for (let i = 0; i < popuplist.length; i++) {
			if (!popuplist[i]) {
				targetIndex = i;
				break;
			}
		}

		// 若未找到空位或未达阈值，追加到数组末尾
		if (targetIndex === -1) targetIndex = popuplist.length;

		// 计算垂直坐标（基础位置10px，每个间距28px）
		const y = 10 + targetIndex * (popupHeight + popupSpacing);

		// 创建并插入新弹窗
		const newPopup = new AchievementPopup(title, description, y, point, textr);
		popuplist[targetIndex] = newPopup;
	}

	// 成就弹窗类
	class AchievementPopup {
		constructor(title, description, position, point, textr) {
			this.title = title;
			this.description = description;
			this.frame = 0;
			this.point = point;
			this.animationFrame = 0;
			this.position = position;
			this.id = Math.random().toString(36).substr(2, 9);
			this.textr = textr;
		}

		draw(ctx, alpha) {
			// 计算动态偏移量（缓动动画）
			let y = this.position;
			if (this.animationFrame < animationDuration) {
				const progress = this.animationFrame / animationDuration;
				const easeOut = 1 - Math.pow(1 - progress, 3); // 三次方缓动
				y -= (popupHeight + popupSpacing) * (1 - easeOut);
				this.animationFrame++;
			}

			/*-- 绘制背景 --*/
			const gradient = ctx.createLinearGradient(10, y, 10 + popupWidth, y);
			gradient.addColorStop(0, `rgba(0, 0, 0, ${0.8 * alpha})`); // 左端不透明
			gradient.addColorStop(1, 'rgba(0, 0, 0, 0)'); // 右端透明
			core.setAlpha(ctx, alpha);
			core.fillRoundRect(ctx, 10, y, popupWidth, popupHeight, 5, gradient);

			/*-- 绘制边框 --*/
			const borderGradient = ctx.createLinearGradient(10, y, 10 + popupWidth, y);
			borderGradient.addColorStop(0, borderColorD);
			borderGradient.addColorStop(1, 'rgba(200, 200, 200, 0)');
			core.strokeRoundRect(ctx, 10, y, popupWidth, popupHeight, 5, borderGradient, 2);

			/*-- 绘制文字 --*/
			const textY = y + popupHeight / 2 + 5; // 垂直居中+基线偏移
			// 绘制标题（带描边效果）
			core.fillBoldText(ctx, this.title, 36, textY, colorD, boldColorD, titleFontD);
			// 计算标题宽度并定位描述
			const titleWidth = core.calWidth(ctx, this.title, titleFontD);
			core.fillBoldText(ctx, this.description, 36 + titleWidth + 8, textY - 1, colorN, boldColorN, fontD);
			const titleWidth2 = core.calWidth(ctx, this.description, fontD);
			core.fillBoldText(ctx, this.textr, 36 + titleWidth + titleWidth2 + 16, textY, colorN, boldColorN, titleFontD);
			// 绘制图标
			let icont = '';
			if (this.point === 0) icont = 'X10147';
			else if (this.point <= 3) icont = 'X10149';
			else if (this.point <= 7) icont = 'X10148';
			else icont = 'X10147';
			core.drawIcon(ctx, icont, 8, textY - 21);

		}

		shouldRemove() {
			return this.frame >= 360;
		}
	}

	/*===== 动画帧处理器调整 =====*/
	function achievementPopup(timestamp) {
		const ctx = core.getContextByName('achievementPopup') ||
			core.createCanvas('achievementPopup', 0, 0, 352, 352, 150);
		core.clearMap(ctx);

		// 更新存活时间并清理过期弹窗
		popuplist.forEach((popup, index) => {
			if (popup) {
				popup.frame++; // 帧计数器在动画循环中统一更新
				if (popup.shouldRemove()) popuplist[index] = undefined;
			}
		});

		// 绘制有效弹窗
		popuplist.forEach(popup => {
			if (popup) {
				let alpha = 1 - popup.frame / 360 * popup.frame / 360 * popup.frame / 360;
				alpha = Math.max(0, Math.min(1, alpha)); // 钳制透明度
				popup.draw(ctx, alpha);
			}
		});

		// 同步状态到核心系统
		core.status.achievementPopups = popuplist.filter(p => !!p);
	}

	// 注册动画循环（保持不变）
	if (!main.replayChecking) {
		core.registerAnimationFrame('achievementPopup', true, achievementPopup);
	}
}
}
